;;;; -*-o Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10 -*-

;(declaim (optimize (debug 2) (speed 1) (safety 1) (compilation-speed 1)))
(declaim (optimize (debug 3) (speed 3) (safety 1) (compilation-speed 0)))

(in-package :asdf)

#+(or allegro lispworks cmu mcl cormanlisp sbcl scl)

(defsystem cello
    :name "cello"
  :author "Kenny Tilton <ktilton@nyc.rr.com>"
  :version "1.0.0"
  :maintainer "Kenny Tilton <ktilton@nyc.rr.com>"
  :licence "MIT"
  :description "A Common Lisp GUI"
  :long-description "A portable Common Lisp GUI built under the dataflow paradigm"
  
  :perform (load-op :after (op cello)
             (pushnew :cello cl:*features*))
  
  :components (
               (:file "cello")
               (:file "datetime")
               (:file "window-macros" :depends-on ("cello"))
               (:file "opengl-extras" :depends-on ("cello"))
               (:file "clipping" :depends-on ("cello"))
               (:file "mg-geometry" :depends-on ("cello"))
               (:file "coordinate-xform" :depends-on ("mg-geometry"))
               (:file "ix-geometry" :depends-on ("coordinate-xform"))
               (:file "colors" :depends-on ("ix-geometry"))
               (:file "frame" :depends-on ("colors"))
               (:file "application" :depends-on ("frame"))
               (:file "image"
                 :depends-on ("window-macros" "clipping"
                              "mg-geometry"
                              "ix-geometry"))                
               (:file "ix-canvas" :depends-on ("cello" "image"))
               (:file "ix-family" :depends-on ("cello" "ix-canvas"))
               (:file "font" :depends-on ("image"))
               (:file "ix-inline" :depends-on ("ix-geometry" "ix-family"))
               (:file "ix-makers" :depends-on ("ix-inline"))
               (:file "ix-grid" :depends-on ("ix-makers"))
               (:file "mouseclick" :depends-on ("ix-grid"))
               (:file "control" :depends-on ("mouseclick"))
               (:file "focus" :depends-on ("ix-canvas"))
               (:file "focus-navigation" :depends-on ("focus"))
               (:file "focus-utilities" :depends-on ("focus-navigation"))
               (:file "ix-formatter" :depends-on ("ix-canvas" "font"))
               (:file "ix-text" :depends-on ("ix-formatter"))
               (:file "lighting" :depends-on ("ix-inline" "ix-makers"))
               (:file "window" :depends-on ("lighting"))
               (:file "ctl-toggle" :depends-on ("control" "ix-text"))
               (:file "ctl-markbox" :depends-on ("ctl-toggle"))
               (:file "ctl-drag" :depends-on ("ctl-markbox"))
               (:file "ctl-selectable" :depends-on ("ctl-drag"))
               (:file "slider" :depends-on ("ctl-selectable"))
               (:file "window-utilities" :depends-on ("window"))
               (:file "window-render" :depends-on ("window-utilities"))
               (:file "wm-mouse" :depends-on ("window-utilities"))
               (:file "button" :depends-on ("ctl-toggle"))
               (:file "window-key" :depends-on ("window-utilities"))
               (:file "pick" :depends-on ("window-key"))
               (:file "menu" :depends-on ("pick"))
               (:file "ix-render" :depends-on ("window-render"))
               (:file "invalidation-echos" :depends-on ("ix-render"))
               (:file "ix-polygon" :depends-on ("invalidation-echos"))
               (:file "ctl-tabstop" :depends-on ("ix-geometry" "control"))
               (:file "starter" :depends-on ("ix-inline" "ix-makers"))
               (:file "hedron" :depends-on ("ix-inline" "ix-makers"))
               (:file "tutor-geometry" :depends-on ("ix-inline" "ix-makers"))
               ))