;;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.


(defpackage :cello
    (:nicknames :clo)
    (:use
     #:common-lisp
     #-cormanlisp #:clos
     #:cells
     #:ffx
     #:opengl-bindings
     )
    ;;; (:shadowing-import-from #:excl #:fasl-write #:fasl-read #:gc)
  (:import-from #:cells #:eko #:count-it #:trc #:maptimes #:bwhen "BIF"
    "WITH-DYNAMIC-FN" #:last1 #:packed-flat! #:with-metrics 
    #-lispworks "TRUE" "MAXF" "SHORTC")
    (:export access-allowed resource-key-held accessControl focus-shared-by
      CTToggleChoice-controlAction
      CTZoomers zoomStep zoomLimit
      make-foldertab CTToggleChoice aNumLabel
      IXShadow client clientOffset ^clientOffset
      ix-ensure-in-view-image
      
      ^PARENTHEIGHT ^PARENTWIDTH
      open-browser-with-file clipped turn-editActive
      content ^content caretRect ^caretRect editRequiresActivation edit-ip-compute
      CANVAS textFont ^selRect ^TEXTFONT ix-string-width FONT-CARET-HEIGHT NRES-TO-RES Nr-OFFSET
      columnSpacing pB cs-waiting-ex
      lValue-in-frame-h lValue-in-frame-v
      CTText-find-ip-fixed CTText-find-ip-variable
      sfocuser wdw swdw Focuser FocusTextMini focuser focus ^Focus ^focused-on
      ctl-handle-over focus-editActive-do CTSelectorStack CTSelectorRow
      mkTwistedPart mkTwisted do-virtual-key-functions selector
      IXBarChart IXDetail keyEvt ^keyEvt initialSelection-first
      IXCanvas IXCanvasNested IXCanvasParentSized IXCanvasKidSized sCanvas wKill editrequiresactivation
      CTEditCaret ^textualFocus ^editActive IXEditSelection
      IXBlob IXDDBitmap IGSplitter IXIcon
      FolderTabGrid FolderTab
      CTTabHeader IXDetails ^details IXDetailsColumn IXDetailsColumnEx columnSpecs ^columnSpecs
      ctfsm-assume-value fully-enabled markbox-frame ASSOCIATEDVALUE
      CTPolygon CTScrollRocker CTScrollPane IGScroller IGScrollerMulti aScroller ^scrollstepv2
      IGScrollBarHZ IGScrollBarVT IXScrollFill
      CTKeyValued CTDetails CTIcon
      ^make-ix-detail-columns make-ix-details do-click
      with-one-invalidation with-modality
      canvas-to-screen-point canvas-to-screen-rect
      nr-outset current-folder focusminded
      focus-lose focus-gain aStackOfKids
      ^lBMax? ^lRMax?
      inset-h inset-v openstate
      rowPadding wrap$
      inset outset with-window-message
      IXStackOfKids
      focus-debug
      buttons-shifted gUnScaled
      kbdModifiers ^kbdModifiers
      ll lt lr lb ^ll ^lt ^lr ^lb lRect
      lheight
      ^priorSib
      lwidth ^best-fit-targetRes
      px ^px *mouseWhere*
      py ^py
      ^ddBitMap  
      visible collapsed layers
      ^visible ^collapsed ^layers
      was-handled
      
      ^py-maintain-pt ^px-maintain-pl
      ^centeredH? ^centeredV?
      ^px-maintain-pr ^py-maintain-pb 
      ^lr-maintain-pr ^lr-width ^insetlr ^insetwidth ^fillright ^fillRightType ^fillDown ^insetHeight
      ^fillParentRight ^fillParentDown
      
      
      ^priorsib-pb ^cell-pr  ^cell-width 
      
      mk-gR goffset gOffsetH gOffsetV offset-within winOffset
      
      ^insetlb
      ^lb-maintain-pb ^lb-height find-ix-under pR
      colpadding allcellwidth ix-orientation-opposite
      selection-set1 v2-xlate selection-set
      do-gpprint 
      current-tab 
      IXTable
      radio-on-name
      
      
      ^find-layer-typed find-layer-typed frame :black :red
      
      focused-on focusthickness focus ^focus focus-change  
      editActive 
      focusedDescendant FocusFamily FOCUS-FIND-FIRST ;; /// vestigial?
      focus-navi-leave focus-navigate
      tabstopp tabMode
      
      ;;;            userActivity ^userActivity
      
      Multitext cello-reset
      
      IXText
      ;-----
      text$ ^text$
      charMask ^charmask
      maxcharwidth ^maxcharwidth
      justifyhz ^justifyhz justifyVt ^justifyVt
      IMLabel
      
      HTPhrase
      ^px-SELF-CENTERED spacingHz
      ^py-self-centered
      
      IXTextTall
      ;---------
      textheight ^textheight
      formatted$ ^formatted$
      
      IXFamily
      ;-------
      styles ^styles
      effectiveStyles ^effectiveStyles
      showkids ^showkids
      kidsevershown ^kidsevershown
      MinKid-lL MinKid-lT MaxKid-lR MaxKid-lB MaxKid-lWidth MaxKid-lHeight
      
      IGZeroTL IXKidSized IMMatrix IGOriented IMORIENTEDCELL
      IXStack IGRow IXRow IGRowFlow inlineCount IXRowFV
      
      Image IXBits backpict  ^backpict texturearrayinfo ^texturearrayinfo
      IMPixFile
      
      targetRes ^targetRes
      
      IXGrid
      ;-----
      colct ^colct
      allcellwidth ^allcellwidth
      allcellheight ^allcellheight
      rowOffsets ^rowOffsets
      colOffsets ^colOffsets
      rowJustifys ^rowJustifys
      colJustifys ^colJustifys
      html-to-parts mkrow
      
      ix-paint
      
      Control
      ;------
      sm-echo-clickEvt clickEvt ^clickEvt ^inDrag
      title$ ^title$ enabled ^enabled hilited ^hilited
      Control-do-action
      
      CTButton CTCheckText
      
      CTDrag dragDirection ^dragDirection
      
      CTSizer CTTabStop
      
      CTFolder IXFolder
      
      CTFSM CTMarkBox CTCheckBox CTCheckText CTRadioButton CTRadio
      CTReorienter CTTwister
      CTTabStopBar  ^ix-orientation  tabdefs  ^tabdefs  fixed ^fixed
      
      CTSelectable ^selected
      
      CTExclusive CTMultiChoice
      CTLabel CTLabelMultiChoice CTLabelExclusive
      CTText
      usertext$ ^userText$
      insertionpt ^insertionpt
      ^caret sm-echo-caret
      selEnd ^selEnd selrect ^selrect selRange ^selRange sm-echo-selRange
      
      CTSelector
      selection ^selection
      selectionFocus ^selectionFocus
      
      TreeView TVNodeDirectory
      
      CTFileDrawer drawerValues ^drawerValues ^selectedp
      cell-col col-head cell-row row-head
      
      aRow aStack
      
      states make-osevent-buttons-where noechotext
      
      mg-window-activate SWINDOW Window
      
      do-menu-right make-menu-right-items menu-right-select  menu-shortc
      
      current-app-universal-time userPreferences
      
      GetCurrentThread  GetThreadPriority SetThreadPriority 
      GetCurrentProcess GetPriorityClass SetPriorityClass
      
      ALABEL aLabelTall AC-MAKE-FONT MAKE-STYLE MKLABEL 
      IGTabbedRow ATABBEDROW ARCHOSW MGSystem
      TNBrowser MKTABHEADERS
      
      ;--- ooops  ---------
      make-tvnode
      ^tickcount
      tv-tree-node-type
      context-cursor
      do-virtual-key
      ^foldertabtitle$
      tickcount
      ctradio-turn-to
      IXFolder-kids
      ^focuseddescendant
      wants-caret
      
      ^fm-parent
      ix-paint-string
      pgno
      focus-on focus-get ix-ensure-in-view
      user-pref-set user-pref ^user-pref user-pref-toggle
      sampleprinter
      do-double-click do-right-button
      foldertab-tabview
      mousePos ^mousePos mouseImage ^mouseImage
      
      ProgressTracker  status-text percent-complete *progress-stepper*
      
      
      ))

(in-package :cello)