;; -*- lisp-version: "6.2 [Windows] (Jun 26, 2002 11:39)"; common-graphics: "1.389.2.105.2.14"; -*-

(in-package :common-graphics-user)

(defpackage :cello (:export))

(define-project :name :cello
  :application-type (intern "Standard EXE" (find-package :keyword))
  :modules (list (make-instance 'module :name "cello.lisp")
                 (make-instance 'module :name "datetime.lisp")
                 (make-instance 'module :name "window-macros.lisp")
                 (make-instance 'module :name "opengl-extras.lisp")
                 (make-instance 'module :name "clipping.lisp")
                 (make-instance 'module :name "mg-geometry.lisp")
                 (make-instance 'module :name "coordinate-xform.lisp")
                 (make-instance 'module :name "ix-geometry.lisp")
                 (make-instance 'module :name "colors.lisp")
                 (make-instance 'module :name "rgb.lisp")
                 (make-instance 'module :name "frame.lisp")
                 (make-instance 'module :name "application.lisp")
                 (make-instance 'module :name "image.lisp")
                 (make-instance 'module :name "ix-canvas.lisp")
                 (make-instance 'module :name "ix-family.lisp")
                 (make-instance 'module :name "font.lisp")
                 (make-instance 'module :name "ix-inline.lisp")
                 (make-instance 'module :name "ix-makers.lisp")
                 (make-instance 'module :name "ix-grid.lisp")
                 (make-instance 'module :name "mouseclick.lisp")
                 (make-instance 'module :name "control.lisp")
                 (make-instance 'module :name "focus.lisp")
                 (make-instance 'module :name "focus-navigation.lisp")
                 (make-instance 'module :name "focus-utilities.lisp")
                 (make-instance 'module :name "ix-formatter.lisp")
                 (make-instance 'module :name "ix-text.lisp")
                 (make-instance 'module :name "lighting.lisp")
                 (make-instance 'module :name "window.lisp")
                 (make-instance 'module :name "ctl-toggle.lisp")
                 (make-instance 'module :name "ctl-markbox.lisp")
                 (make-instance 'module :name "ctl-drag.lisp")
                 (make-instance 'module :name "ctl-selectable.lisp")
                 (make-instance 'module :name "slider.lisp")
                 (make-instance 'module :name "window-utilities.lisp")
                 (make-instance 'module :name "window-render.lisp")
                 (make-instance 'module :name "wm-mouse.lisp")
                 (make-instance 'module :name "button.lisp")
                 (make-instance 'module :name "window-key.lisp")
                 (make-instance 'module :name "pick.lisp")
                 (make-instance 'module :name "menu.lisp")
                 (make-instance 'module :name "ix-render.lisp")
                 (make-instance 'module :name
                                "invalidation-echos.lisp")
                 (make-instance 'module :name "ix-polygon.lisp")
                 (make-instance 'module :name "starter.lisp")
                 (make-instance 'module :name "tutor-geometry.lisp")
                 (make-instance 'module :name "hedron.lisp"))
  :projects (list (make-instance 'project-module :name
                                 "..\\opengl-ffi\\opengl-ffi")
                  (make-instance 'project-module :name
                                 "..\\cells\\cells"))
  :libraries nil
  :distributed-files nil
  :project-package-name :cello
  :main-form nil
  :compilation-unit t
  :verbose nil
  :runtime-modules '(:cg :drag-and-drop :lisp-widget
                     :multi-picture-button :common-control
                     :edit-in-place :outline :grid :group-box
                     :header-control :progress-indicator-control
                     :common-status-bar :tab-control :trackbar-control
                     :up-down-control :dde :mci :carets :hotspots
                     :menu-selection :choose-list :directory-list
                     :color-dialog :find-dialog :font-dialog
                     :string-dialog :yes-no-list-dialog
                     :list-view-control :rich-edit :drawable :ole :www
                     :aclwin302)
  :splash-file-module (make-instance 'build-module :name "")
  :icon-file-module (make-instance 'build-module :name "")
  :include-flags '(:compiler :top-level :local-name-info)
  :build-flags '(:allow-debug :purify)
  :autoload-warning t
  :full-recompile-for-runtime-conditionalizations nil
  :default-command-line-arguments "+cx +t \"Initializing\""
  :old-space-size 256000
  :new-space-size 6144
  :runtime-build-option :standard
  :on-initialization 'cello::starter
  :on-restart 'do-default-restart)

;; End of Project Definition
