;; -*- mode: Lisp; Syntax: Common-Lisp; Package: Cello; -*-
;;__________________________________________________________
;;
;;
;;          C T D r a g
;;


(in-package :cello)


(defmodel CTDrag (Control Image)
  ((dragDirection :initarg :dragDirection :accessor dragDirection
     :documentation ":hz, :vt, or :hz-vt")
   (dragPct :initarg :dragPct :accessor dragPct :initform (cv (mkv2 0 0)))
   (dragRange :initarg :dragRange :reader dragRange
              :initform (c? (count-it :dragRange)
                          (eko (nil "dragrange")
                            (let ((dl (- (lL .parent) (^ll)))
                                  (dt (- (lT .parent) (^lt)))
                                  (dr (- (lR .parent) (^lr)))
                                  (db (- (lB .parent) (^lb))))
                              (mkr dl dt dr db)))))
   (dragPos :initarg :dragPos :accessor dragPos :initform (mkv2 0 0))
   )
  
  (:default-initargs
      :click-tolerance (mkv2 (u8ths 4)(u8ths 4))
    :px (c? (v2-h (^dragPos)))
    :pY (c? (v2-v (^dragPos)))
    :dragPos (c? (bIf (e (^clickEvt))
                   (eko (nil "clickevt -> dragpos(c?)")
                     (v2-in-rect (v2-add (v2-subtract (^mousePos .w.)
                                           (evtWhere (osEvent e)))
                                   (clickeePXY e))
                       (^dragRange)))
                   (eko (nil "dragpct -> dragpos(c?)")
                     (mkv2 (+ (r-left (^dragRange))
                             (* (v2-h (dragPct self)) (r-width (^dragRange))))
                       (+ (r-bottom (^dragRange))
                         (* (v2-v (dragPct self)) (r-height (^dragRange))))))))

    ))

(defun div-safe (n d)
  (if (zerop d) 0 (/ n d)))

(def-c-echo dragpos ((self CTDrag))
  (when new-value
    (bIf (dragr (^dragRange))
      (let ((dh (- (v2-h new-value) (r-left dragr)))
            (rw (r-width dragr))
            (dv (- (v2-v new-value) (r-bottom dragr)))
            (rh (r-height dragr)))
        (trc "echo dragpos" new-value dragr dh rw dv rh)
        (setf (dragPct self)
          (eko ("dragpos echo -> dragpct")
            (mkv2
             (div-safe dh rw)
             (div-safe dv rh)))))
      (trc "no dragr for ctdrag?" self new-value))))

(defmethod context-cursor ((self CTDrag) kbdModifiers)
   (declare (ignore kbdmodifiers))
   (ecase (dragdirection self)
     (:hz GLUT_CURSOR_LEFT_RIGHT)
     (:vt GLUT_CURSOR_UP_DOWN)
     (:hz-vt GLUT_CURSOR_CROSSHAIR)))



(defmodel CTPolyDrag (CTDrag IXPolygon)())

(defmodel tab-bar-tracker ()
  ((tab-bar :reader tab-bar
     :initform (c? (let ((tracker (fm-other :htabs)))
                     (assert tracker)
                     tracker)))))

