;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :Cello)

;_____________________ N a v i g a t i o n  ____________________
;
(defun focus-navigate (old new &optional leaveOld)
  #+navi (trc "focus-navigate > old, new" old new)
  ;; (c-assert new) ;; 990810kt i don't remember if we navigate to nil (should tho) ///

  (when (eql old new)
    (return-from focus-navigate new))
  
  (unless old
    (focus-navi-enter new)
    (focus-on new)
    (return-from focus-navigate new))
  
  (let ((resting
         (catch :focus-navigate
            (let (in-range)
               (labels ((step-stone (stone)
                                    ;;(trc "step-stone" stone in-range)
                                    (when (eql stone new)
                                      (when (and leaveOld old)
                                        (setf leaveOld nil)
                                        (focus-navi-leave old))
                                      (when in-range ; if not in range, navving backwards
                                        (focus-navi-enter stone))
                                      (throw :focus-navigate new))
                                    (when (kids stone)
                                      (dolist (kid (kids stone))
                                        (step-stone kid)))
                                    (when (eql stone old)
                                      (setf in-range t))
                                    (when in-range
                                      (setf leaveOld nil)
                                      (focus-navi-leave stone))))
                 ;
                 (step-stone (fm-ascendant-common old new))
                 ;; (step-stone (focus-navi-cares (fm-ascendant-common old new) old))
                 ;
                 )))))
     #+nah (trc "focus-navigate > BINGO: root, old, new, newtracker"
          (find-focus-root resting) old resting (focuser resting))
     (with-metrics (nil nil "Actual set focus")
       (focus-on resting))
     ))

(defun focus-navi-cares (topFocus startFocus)
  (cond ((eql topFocus startFocus) startFocus)
        ((focus-cares topFocus) topFocus)
        (t (focus-navi-cares (fm-kid-containing topFocus startFocus) startFocus))))

(defmethod focus-cares (wk)
  (declare (ignore wk))
  t)

(defmethod focus-navi-enter (Work)
   (declare (ignorable Work))
  #+navi (trc "focus-navi-enter >" work)
   )

(defmethod focus-navi-leave (Work)
  (declare (ignore Work)))

