(in-package :cello)

(defmodel font-id (IXText)
  ()
  (:default-initargs
      :textFont (c? (ftgl-font-ensure .w. 'texture 
                      (intern (^md-value)) 14))
    :text$ (c? (string-capitalize
                (or (^md-value) ;; ever not?
                  "Blank")))))

(def-c-echo mouse-over-p ((self font-id))
  (when new-value
    (setf (md-value (fm-other :ftgl)) (^md-value))))

(defun ftgl-test ()
  (let ((fns (mapcar (lambda (p)
                           (pathname-name p))
                   (directory "c:/windows/fonts/*.ttf")))
            (cols 6))
        (flet ((mk-font-show (col-no row-no)
                 (when (nth (+ (* cols row-no) col-no) fns)
                   (mkPart :ftest (font-id)
                     :md-value (c? (let ((row-no (kid-no self)))
                                     (elt fns (+ (* cols row-no) col-no))))))))
          (aStack (:md-name :ftgl :spacing (uPts 10) :px 0 :py (uIn 1)
                    :md-value (cv (car fns))
                    :justify :center)
            (aStack (:lb (downs (upts 48))
                      :justify :center
                      :outset (upts 8)
                      :layers (list :on +gray+ (make-instance 'Frame3D
                                                 :3dStyle :EDGE-SUNKEN
                                                 :thickness (u96ths 4))
                                :off +white+ :fill-lr +black+)
                      )
              (loop for line below 2
                    collect (mkPart :sample (IXText)
                              :lighting :off
                              :text$ (nth line
                                       (list "Ah, would that the Gods had this gift to gie us,"
                                         "to see ourselves as others see us"))
                              :textfont (c? (ftgl-font-ensure .w. 
                                              (car (md-value (fm-other :mode))) 
                                              (intern (md-value (fm-other :ftgl)))
                                              18 ;; (* 12 (1+ (mod x 4)))
                                              )))))
            (mkPart :mode (CTRadioRow)
              :spacing (uPts 4)
              :md-value (cv (list 'texture))
              :clipped nil
              :kids (c? (loop for mode in '(bitmap pixmap texture outline polygon extruded)
                            collect (mkPart :rb (CTRadioText)
                                      :associatedvalue mode
                                      :title$ (string-capitalize
                                               (format nil "~d" mode))))))
            (mkPart :ftgrow (IXROW)
              :layers (list +white+ :fill-lr)
              :kids (c? (thekids
                         (loop repeat cols
                               collecting
                               (mkPart :fstk (IXSTack)
                                 :kids (c? (let ((col-no (kid-no self)))
                                             (loop for row-no below (ceiling (length fns) cols)
                                                 when (mk-font-show col-no row-no)
                                                 collect it))))))))))))

(defun ftgl-font-write (w face size)
  (let ((f (ftgl-font-ensure w 'texture face size)))
    (with-open-file (out (format nil "/dev/toy-edit/~a~a.lisp" face size)
                      :direction :output
                      :if-exists :supersede)
      (let ((d (make-array 256 :element-type 'single-float
               :initial-contents
               (loop for ascii below 256
                   collect (font-string-length
                            f (char$ (code-char ascii)))))))
        (print d)
        (print `(push (make-toy-font :face ',face :size ,size
                        :ascent ,(font-ascent f)
                        :descent ,(font-descent f)
                        :widths ,d)
                  *toy-fonts*) out)))))