;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :cello)

(eval-when (:compile-toplevel :load-toplevel :execute)
 ;;
 ;; dirty Constants
 ;;
 (defconstant $DirtyOld 1)
 (defconstant $DirtyNew 2)
 (defconstant $DirtyOldNew 3)
 (defconstant $DirtyGeo 4)
 (defconstant $DirtyContents 8))

;___________________________________________
;
;          s m - e c h o   d i r t y    t r i g g g e r s
;
(defmacro talkdirty (smname &optional (img 'img))
   `(trc "talkDirty>" ',smname :self ,img "new:" newvalue (invalidating (wdw ,img))))


(defgeneric ekko2 (name)
  (:method-combination progn))

(defmethod ekko2 progn (symbol)
  (trc "hello frome kko2" symbol))

;--------------- md-value -------------------------------
;
; new for 990401kt: tailor to your needs. The question is,
; if my md-value changes, do I need to be redrawn? In the
; case of a composite field which repeatedly recomputes its
; md-value each time one atom changes, no, the atoms just need
; redrawing.
;
(def-c-echo md-value ((img Image))
  (image-set-dirty img $DirtyOld 'value))


(def-c-echo px (img)
 (image-set-dirty img $DirtyGeo  'px))

(def-c-echo py (img)
 (image-set-dirty img $DirtyGeo  'py))

(def-c-echo lL (img)
  (c-assert new-value)
  ;;(trc "ll dirty" img)
  (image-set-dirty img $DirtyGeo 'lleft))

(def-c-echo dvErrorHidden (img)
  ;; (talkdirty 'dvErrorHidden)
  (image-set-dirty img $DirtyOld 'dvErrorHidden))

(def-c-echo selectedp (img)
  ;;(talkdirty selected)
  (image-set-dirty img $DirtyOld 'selected))

(def-c-echo selBox (self)
  ;;(trc "set dirty selbox" newvalue)
  (image-set-dirty self (if new-Value $DirtyNew $DirtyOld) 'selBox))

(def-c-echo hilited (img)
  ;;(talkdirty hilited)
  (image-set-dirty img $DirtyOld 'hilited)
  )

(def-c-echo WorkTask ((self Image))
  ;;(talkdirty WorkTask)
  (image-set-dirty self $DirtyOld 'hilited))

(def-c-echo justifyHZ (img)
 ;;(trc "lT dirty" img)
 (image-set-dirty img $DirtyOld 'ltop))

(def-c-echo justifyVT (img)
 ;;(trc "lT dirty" img)
 (image-set-dirty img $DirtyOld 'ltop))

(def-c-echo lT (img)
  (c-assert new-value)
 ;;(trc "lT dirty" img)
 (image-set-dirty img $DirtyGeo 'ltop))

(def-c-echo lR (self)
;;;   (c-assert newvalue)
;;;   (c-assert (numberp newvalue))
;;;   (c-assert (>= newValue (ll self)))
  ;;(talkdirty lR)
  (image-set-dirty self $DirtyGeo 'lright))

(def-c-echo lB (img)
;;;   (c-assert newvalue)
  ;(talkdirty lB)
  (image-set-dirty img $DirtyGeo 'lbottom))

(def-c-echo visible ()
  ;; (trc "sm-echo > visible" self newvalue (gBox self))
  (image-set-dirty self (if new-Value $DirtyNew $DirtyOld) 'visible)
  )

(def-c-echo collapsed (img newValue)
  ;;(talkdirty collapsed)
  (image-set-dirty img (if newValue $DirtyOld $DirtyNew ) 'collapsed))

(def-c-echo text$ (img)
  (image-set-dirty img $DirtyOld 'text$)
  )

(def-c-echo ix-orientation (img)
  ;(trc "sm-echo ix-orientation > invalidating img" img)
  (image-set-dirty img $DirtyOld 'ix-orientation))

(def-c-echo textureArrayInfo (img)
  (image-set-dirty img $DirtyOld 'textureArrayInfo))

(def-c-echo layers ((img Image))
  (image-set-dirty img $DirtyOld 'layers))

(def-c-echo textFont (self)
   (image-set-dirty self $Dirtyoldnew 'textFont))

