;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :cello)

;------------------------------------------------------------
(defmodel IXPolygon (Image)
   ((forecolor :initarg :forecolor :initform +black+ :accessor forecolor)
    (polystyle :initarg :polystyle :initform nil :accessor polystyle)
    (polythickness :initarg :polythickness :initform (u96ths 1) :accessor polythickness)
    (polysymmetry :initarg :polysymmetry :initform nil :accessor polysymmetry)
    (vertices :initarg :vertices :initform nil :accessor vertices)))

(defmethod ix-render ((self IXPolygon))
  (let ((gH0 (lL self)) (gV0 (lT self)))
    (flet ((g2d (vertex) (mkv2 (+ (car vertex) gH0) (+ (cdr vertex) gV0)))
           (sym2d (vertex) (mkv2 (+ (cdr vertex) gH0) (+ (car vertex) gV0))))
      (let ((vs (if (polySymmetry self)
                    (append (mapcar #'g2d (vertices self))
                            (nreverse (mapcar #'sym2d (vertices self))))
                  (mapcar #'g2d (vertices self)))))
        (gl-pushm)
        (ix-render-layer (forecolor self) nil)
        (gl-line-width (polythickness self))
        (within-gl-begin-end (GL_LINES)
          (dolist (v vs)
            (gl-vertex3f (v2-h v) (v2-v v) 0)))
        (ogb::glec :f3d)
        (gl-popm)
        ))))

