;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :cello)


;-------- catchall -----------------------------

(defmethod ix-render :after ((self family))
  (dolist (k (kids self))
    (with-clipping (self)
      (progn
        (trc nil "ixr geo" k (list (px k)(py k)) (list (lL k)(lT k)(lR k)(lB k))))
      (trc nil "render kid moving for kid" k (px k)(py k))
      (c-assert (px k) () "pX is null in ~a" k)
      (c-assert (py k) () "pY is null in ~a" k)
      (let ((px (px k))(py (py k)))
        (gl-translatef px py 0)
        (gl-raster-pos2i 0 0)

        (when (not (cello-get-boolean GL_CURRENT_RASTER_POSITION_VALID))
          (trc nil "ix-render rasterpos offscreen" self :goffset (gOffset self)))

        (progn
          (unless (typep k 'Window) ;; GLUT gives them their own display callback
            (ix-render k))
          )
        (gl-translatef (- px) (- py) 0)
        ))))

(defmethod ix-selectable ((self family)) t)

(defmethod ix-render-layer ((layers list) lBox)
  ;; Supports nested lists in layers
  (dolist (layer layers)
    ;(trc "IX paint layer" image)
    (ix-render-layer layer lBox)))

(defmethod ix-render-layer ((ztran number) lBox)
  (declare (ignore lBox))
  ;; (trc "render N translating Z" ztran)
  (gl-translatef 0 0 ztran))
        

;--------  RGB ---------------

(defmethod ix-render-layer ((nada null) gbox)
  (break "NIL layer detected" gbox))


;-------------------
