(in-package :cello)

(defparameter *Bright* (make-ff-array :float 1 1 1 1))
(defparameter *BRed* (make-ff-array :float 1 0 0 1))

(defparameter *Average* (make-ff-array :float 0.5f0 0.5f0 0.5f0 1.0f0))
(defparameter *Dim* (make-ff-array :float 0.25f0 0.25f0 0.25f0 1.0f0))
(defparameter *Dusk* (make-ff-array :float 0.10f0 0.10f0 0.10f0 1.0f0))
(defparameter *blackout* (make-ff-array :float 0f0 0f0 0f0 1.0f0))
(defparameter *LightPosTR* (make-ff-array :float 640 0 (outs 100) 1))
(defparameter *LightPosTL* (make-ff-array :float 0 0 (outs 100) 1))
(defparameter *LightPosL* (make-ff-array :float 0 -400 (outs 50) 1))
(defmodel ix-light (ixstack)
  ()
  )

(defmodel light ()
  ((id :cell nil :initarg :id :initform nil :accessor id)
   (enabled :initarg :enabled :initform nil :accessor enabled)
   (pos :initarg :pos :initform nil :accessor pos)
   (ambient :initarg :ambient :initform nil :accessor ambient)
   (diffuse :initarg :diffuse :initform nil :accessor diffuse)
   (specular :initarg :specular :initform nil :accessor specular)))
   
   
(defun light-install (self)
  (trc nil "lightinst" (id self) (^enabled) (^pos)(^ambient)(^diffuse)(^specular))
  (funcall (if (^enabled) 'gl-Enable 'gl-Disable) (id self))
  (gl-Lightfv (id self) GL_POSITION (^pos))
  (gl-Lightfv (id self) GL_AMBIENT (^ambient))
  (gl-Lightfv (id self) GL_DIFFUSE (^diffuse))
  (gl-Lightfv (id self) GL_SPECULAR (^specular)))

(defun pct-xlate (pct v1 v2 expansion)
  (let* ((dv (round (- v2 v1) 2))
         (xv1 (- v1 (* expansion dv)))
         (xv2 (+ v2 (* expansion dv))))
    (+ xv1 (* pct (- xv2 xv1)))))

