(in-package :cello)

(defun glut-mouse-is-over (pos self)
  (r-contains (gBox self) pos)
  ;; following works, but too much work when above suffices
  #+not (member self
          (ix-select pos (click-tolerance self) :target self)))

(uffi:def-foreign-type uint* (* GLuint))
(uffi:def-foreign-type int* (* GLint))

#-lispworks
(declaim (type int* *ix-select-r*))
(defparameter *ix-select-r*
  (uffi:allocate-foreign-object 'GLint 4))

;;;(defvar *ix-select-names*
;;;  (uffi:allocate-foreign-object 'GLuint 1))

(defun view-b (n)
  (uffi:deref-array *ix-select-r* '(:array GLint) n))

#-lispworks
(declaim (type uint* *ix-select-buffer*))
(defparameter *ix-select-buffer* (uffi:allocate-foreign-object 'GLuint 512))
(defun buffy (y)
  (uffi:deref-array *ix-select-buffer*
                    '(:array GLuint)
                    y))

(defun ix-select (pos tolerance &key (select :nearest) (target (mg-window-current)))											
  (gl-get-integerv gl_viewport *ix-select-r*)
  (dotimes (n 4)
    (print `(bound ,n ,(view-b n))))
  (gl-select-buffer 512 *ix-select-buffer*)
  (gl-render-mode gl_select)
  (gl-init-names)
  (gl-push-name 0)
  (gl-matrix-mode gl_projection)
  (gl-push-matrix)
  (gl-load-identity)

  (when pos ;; pass nil to select all visible
    (glu-pick-matrix
     (v2-h pos) (- (view-b 3) (v2-v pos)) ;;OQ: are GLUT mouse y's up or down?
     (v2-h tolerance) (v2-v tolerance) *ix-select-r*))

  (let ((aspect (/ (- (view-b 2)(view-b 0))
                            (- (view-b 3)(view-b 1)))))
    ;;(format t "~&perspective sees aspect: ~a" aspect)
    (glu-perspective 45 aspect 0.1 100.0)) ;;OQ: appropriate for ortho?
  
  (gl-matrix-mode gl_modelview)
  (let ((*selecting* t))
    (ix-render target))

  (gl-matrix-mode gl_projection) 
  (gl-pop-matrix)
  
  (gl-matrix-mode gl_modelview)

  (let ((hits (gl-render-mode gl_render)))
    (when (plusp hits)
      (print `(:hits ,hits))
      (flet ((dist (n)
               (buffy (1+ (* n 4))))
             (self (n)
               (buffy (+ 3 (* n 4)))))
        (ecase select
          (:all (let ((names (maptimes (x (1- hits))  #'self )))
                  (fm-collect-if target (lambda (node)
                                          (member (glName node) names)))))
          (:nearest (let ((closest 0))
                      (dotimes (n (1- hits))
                        (let ((next (1+ n)))
                          (if (< (dist next) (dist closest))
                              (setf closest next))))
                      (values (fm-find-if target (lambda (node)
                                            (eql closest (glName node))))
                        (dist closest)))))))))

