(in-package :cello)

(defmodel ct-jumper (control image)())



(defun make-slider (md-name &key (md-value-fn 'identity)
                     (initial-pcts (list (mkv2 .50 .50)))
                     (width (uin 1)) (height (u8ths 1))
                     (bar-color +gray+)
                     (drag-dir :hz) (dragger-size (u8ths 1)) (dragger-color +gray+))
  (make-part md-name 'IXFamily
    :lL 0 :lT 0 :lR width :lB (downs height)
    :lighting :off
    :md-value (c? (let ((vs (loop for k in (rest (^kids))
                                collecting (funcall md-value-fn (^dragPct k)))))
                    (if (cdr vs) vs (car vs))))
    :kids (c? (theKids
               (mkPart :bar (ct-jumper)
                 :px 0 :py 0
                 :lL 0 :lR (c? (lwidth .parent))
                 :lT 0 :lB (downs height)
                 :layers (c? (list bar-color :on 
                               (make-instance 'Frame3D
                                 :3dStyle :EDGE-SUNKEN
                                 :of-window .w.
                                 :w-box (gbox self)
                                 :thickness (u96ths 6))))
                 :enabled (c? (null  (cddr (kids .parent))))
                 :controlaction (lambda (self e)
                                  (setf (dragPct (nsib))
                                    (eko ("jumper -> dragpct")
                                      (v2-in-rect-ratio
                                       (v2-in-rect (v2-subtract
                                                    (v2-xlate .w. self (evtwhere e))
                                                    (mkv2 (round (lwidth (nsib)) 2)
                                                      (downs (round (lheight (nsib)) 2)))
                                                     )
                                         (^dragRange (nsib)))
                                       (^dragRange (nsib)))))))

               (loop for ipct in initial-pcts
                     collecting (mkPart :dragger (CTDrag)
                                  :dragPct (cv8 ipct)
                                  :dragDirection drag-dir
                                  :lighting :on
                                  :lL 0 :lr dragger-size
                                  :lT 0 :lB (downs dragger-size)
                                  :layers (list (outs 24) dragger-color :on 
                                            (make-instance 'Frame3D
                                              :3dStyle :EDGE-RAISED
                                              :thickness (u96ths 4)))))))))