(in-package :cello)

(defun starter ()
  (let ((cells::*c-debug* t))
    (run-window
     ;(make-lesson6-w)
     (make-starter-w)
     ;(make-lesson14-w)
     )))

(defmodel lesson14-w (window)())
(defun make-lesson14-w (&key (offset (mkv2 0 0)))
  (declare (ignorable offset))
  (make-instance 'lesson14-w
    :display-continuous nil
    :md-name :lesson6-w
    :glut-xy offset
    :lL 0 :lr (cv 640) :lT 0 :lB (cv -480)
    :title$ "NeHe Lesson 14"
    :lights nil 
    :clear-rgba (list 0 0 1 1)
    :layers nil
    :clipped nil))

(defparameter g_rot 0.0f0)

(defmethod ix-render :around ((self lesson14-w))
  (gl-matrix-mode GL_PROJECTION)
  (gl-Load-Identity)
  (glu-Perspective 70d0 1d0 1d0 1000d0)
  (glu-Look-At 0d0 0d0 5d0 0d0 0d0 0d0 0d0 1d0 0d0)

  (gl-Matrix-Mode GL_MODELVIEW)
  (ogb::nh14-disp))

(defun make-nested-w (offset)
  (make-instance 'window
    :md-value nil
    :display-continuous nil
    :md-name :nested-w
    :glut-xy offset
    :lL 0 :lT 0
    :title$ "Hello, nest"
    :layers (list +red+ :fill-lr)
    :lighting :off))

(defun make-starter-w (&key (offset (mkv2 0 0)))
  (make-instance 'window
    :md-value (list
               (tu-geo)
               ;(imagick-test)
               ;(ftgl-test)
               (make-widgets)
               (light-panel)
               ;(cloucell)
               )
    :display-continuous t
    :md-name :starter-w
    :glut-xy offset
    :lL 0 :lT 0
    :title$ "Hello, world"
    :skin nil #+celloglut (c? (load-texture 'wand-texture
                (car (md-value (fm-other :texture-picker)))
                ;;"/dev/texture/skin.jpg"
                ;;"/dev/texture/metal2.jpg"
                ;;"/dev/texture/drops.jpg"
                ;;"/hayden/titansp2.jpg"
                ))
    :lighting :on
    :clear-rgba (list 0 0 0 1)
    :lights (c? (count-it :lights-collected)
              ;;(print `(collecting lights ,cells::*cause*))
              (or (let (lights)
                          (fm-traverse self (lambda (self)
                                              (count-it :light-typep (type-of self))
                                              (when (typep self 'window)
                                                (print `(glutw= ,(glutw self))))
                                              (when (typep self 'ix-light)
                                                (bwhen (mv (^md-value))
                                                  (push mv lights)))))
                          (nreverse lights))
                (list (make-instance 'light
                        :id GL_LIGHT0
                        :enabled t
                        :pos (make-ff-array :float 800 -800 (outs 100) 1)
                        :ambient *DIM*
                        :diffuse *Bright*
                        :specular *Bright*)
                  (make-instance 'light
                    :id GL_LIGHT1
                    :enabled t
                    :pos (make-ff-array :float 0 0 (outs 200) 1)
                    :ambient *dim*
                    :diffuse *Bright*
                    :specular *Bright*)))) 
    
    :layers (c? (list (ins 1300)
                  ;:off
                  +white+
                  (^skin)
                  ;:on
                  (outs 1300)
                  ))
    :clipped nil
    :content (starter-w-content)
    :kids (c? (thekids (^content)))))
  
(defun starter-w-content ()
  (c? (aStack (:px 0 :py 0 :spacing (u8ths 3))
        (aRow (:spacing (u8ths 1) :justify :center)
          (mkPart :rate (frame-rate-text))
          (aStack()
            #+celloglut (aRow (:spacing (u8ths 1))
              (aLabel "Skins" :layers +white+)
              (let ((jpegs (directory "/dev/texture/*.jpg")))
                (mkPart :texture-picker (CTRadioRow)
                  :spacing (uPts 4)
                  :md-value (cv (list (car jpegs)))
                  :clipped nil
                  :kids (c? (mapcar (lambda (p)
                                      (mkPart :rb (CTRadioText)
                                        :associatedvalue p
                                        :title$ (pathname-name p)))
                              jpegs)))))
            (aRow (:spacing (u8ths 1))
              (aLabel "Demos" :layers +white+)
              (mkPart :demo (CTRadioRow)
                :spacing (uPts 4)
                :md-value (cv (list :lighting))
                :clipped nil
                :kids (c? (mapcar (lambda (s)
                                    (mkPart :rb (CTRadioText)
                                      :associatedvalue s
                                      :title$ (string-capitalize
                                               (format nil "~d" s))))
                            (mapcar 'md-name (^md-value .w.))))))))
        (mkPart :demos (igzerotl)
          :py (u8ths 4)
          :kid-slots (lambda (self)
                       (declare (ignore self))
                       (list
                        (mk-kid-slot (visible)
                          (c? (eql (md-name self)
                                (car (^md-value (fm-other :demo))))))
                        (mk-kid-slot (pX)
                          (c? (^px-maintain-pl 0)))
                        (mk-kid-slot (py)
                          (c? (^py-maintain-pt 0)))
                        ))
          :kids (c? (^md-value .w.))))))

(defun light-panel ()
  (aRow (:md-name :lighting :px (u8ths 4) :py (u8ths (downs 4))
          :spacing (u8ths 3) :justify :top)
    
    (arow ()
      ;(make-lighting :light0 GL_LIGHT0 *LightPosTL*)
      (make-lighting :light1 GL_LIGHT1 *LightPosTR*))
    (starter-hedron)))

(defun make-widgets ()
  (aRow (:md-name :widgets :px 0 :py 0 :spacing (uPts 10))
    (aRow ()
      (starter-toolbar)
      (starter-hedron))
    
    (mkPart :socket (WindowSocket)
      :px (uIn 2)
      :window-factory (lambda (socket glut-xy)
                        (declare (ignorable socket glut-xy))
                        (make-starter-w :offset glut-xy))
      :gen-window-p (c? (^md-value (cells::fm-find-one (upper self Window)
                                     :nested
                                     :must-find t
                                     :skiptree self
                                     :global-search nil))))))
  
(defparameter *starter-font* nil)

(defparameter *rot* 0)

(defparameter *idle-angle* 0)

(defun starter-toolbar ()
  (aStack (:spacing (uPts 10))
    (mkPart :hw (CTButton)
      ;:inset (mkv2 (uPts 4)(uPts 2))
      ;:lr (uin 1)
      :text$ "Close"
      :controlAction (lambda (self event &aux (gw (glutw .w.)))
                       (declare (ignorable event))
                       (trc "whacking" .w. gw)
                       (glut-Destroy-Window gw)))
    
    (mkPart :neww (CTButton)
      ;:inset (mkv2 (uPts 4)(uPts 2))
      ;:lR (uIn 1)
      :text$ "New"
      :controlAction (lambda (self event)
                       (declare (ignorable self event))
                       (push (make-starter-w)
                         (kids *sys*))))
    
    (mkPart :nested (CTCheckText)
      :md-value (cv nil)
      :title$ "Nested")))

(defun starter-flag ()
  (aRow (:lighting :off)
    (mkPart :one (Image)
       :lL (u8ths -2) :lT 0 :lr (u8ths 2) :lb (downs (u8ths 2))
       :lighting nil
       :layers (list +red+ :fill-lr))
    (mkPart :canvasflag (IXCanvasKidSized)
       :targetRes 96
       :kids (theKids 
              (mkPart :two (Image)
                 :px 0 :py 0
                 :lL (u8ths -2) :lT 0 :lr (u8ths 2) :lb (downs (u8ths 2))
                 :layers (c? (trc "s mi" self (^mouseImage .w.)
                               (^mouse-over-p))
                          (list (if (^mouse-over-p)
                                    +black+ +blue+)
                            :fill-lr))))
       :layers +black+)
    (mkPart :tree (Image)
       :lL (u8ths -2) :lT 0 :lr (u8ths 2) :lb (downs (u8ths 2))
       :layers (list +green+ :fill-lr))
    ))




(defun make-lighting (md-name id pos)
  (declare (ignorable id pos))
  (make-part md-name 'ix-light
    :md-value (c? (make-instance 'light
                    :id id
                    :enabled (md-value (fm-other :enabled))
                    :pos  (md-value (fm-other :xyz-pos))
                    :ambient (rgba-fo (md-value (fm-other :ambient)))
                    :diffuse (rgba-fo (md-value (fm-other :diffuse)))
                    :specular (rgba-fo (md-value (fm-other :specular)))))
    :justify :right
    :spacing (u16ths 1)
    :kids (c? (thekids
               (mkPart :enabled (CTCheckText)
                 :md-value (cv t)
                 :title$ (string-capitalize (string md-name))
                 :layers +white+
                 :clipped nil
                 :enabled t)
               (aRow (:md-name :xyz-pos
                       :md-value (c? (eko ("xyz c?")
                                       (let* ((ks (^kids))
                                              (xy (^md-value (car ks))))
                                         (make-ff-array :float
                                           (eko ("light pos x" (v2-h xy))
                                             (pct-xlate (v2-h xy) (ll .w.) (lr .w.) .50))
                                           (pct-xlate (v2-v xy) (lb .w.) (lt .w.) .50)
                                           (pct-xlate (v2-v (^md-value (second ks)))
                                              *mgw-zfar* *mgw-znear* .50)
                                           1)))))
                 (make-slider :xy-pos
                   :width (uin 1) 
                   :height (uin 1))
                 (make-slider :z-pos
                   :width (u8ths 1) 
                   :height (uin 1)))
               (astack (:justify :right)
                 (alabel "ambience" :layers +white+)
                 (make-rgba-mixer :ambient))
               (astack (:justify :right)
                 (alabel "diffusion" :layers +white+)
                 (make-rgba-mixer :diffuse))
               (astack (:justify :right)
                 (alabel "specular" :layers +white+)
                 (make-rgba-mixer :specular))))))

(pct-xlate .10 500 -500 0)