(in-package :cello)

(defmodel tu-box (image)
  ((color :initarg :color :accessor color :initform nil))
  (:default-initargs
      :lR (C? (^lr-width 125))
    :lb (C? (^lb-height (downs 125)))
    :lighting :off
    :layers (c? (list (gloff GL_TEXTURE_2D)
                  (outs 200) (color self) (make-line-width :value 3) :line-lr))))

(defmethod ix-render ((self tu-box))
  (gl-polygon-mode GL_FRONT_AND_BACK GL_FILL)
  (gl-line-width 4)
  (gl-rectf -2 2 2 -2))

(defun degree-radians (degrees)
  (/ degrees #.(/ 180 pi)))

(defun tu-geo ()
  (mkpart :tu-geo (igzerotl)
    :kids (c? (thekids
               
               (mkPart :ftgrow (tu-box)
                 :px 50 :py -100
                 :color +red+
                 :lL -25 :lT (ups 25))
               (mkPart :ftgrow (tu-box)
                 :px 300 :py -100
                 :color +green+
                 :lL 0 :lT 0)
               (mkPart :ftgrow (tu-box)
                 :px 500 :py -100
                 :color +yellow+
                 :lL 25 :lT (ups -25))
               (mkPart :hw (CTButton)
                 :px (c? (/ (lwidth .w.) 2))
                 :py (c? (downs (/ (lheight .w.) 2)))
               
                 ;;:inset (mkv2 (uPts 4)(uPts 2))
                 :text$ "Close"
                 :controlAction (lambda (self event &aux (gw (glutw .w.)))
                                  (declare (ignorable event))
                                  (glut-Destroy-Window gw)))
              (mkPart :ftgrow (tu-box)
                 :px 300 :py -500
                 :color +yellow+
                 :md-value (c? (degree-radians (mod (frame-ct .w.) 360)))
                 :lL (c? (+ -62.5 (* 62.5 (cos (^md-value)))))
                 :lT (c? (+ 62.5 (* -62.5 (sin (^md-value)))))
                 )))))

                             
