;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright  2004 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :cello)

(define-symbol-macro .w.
    (or (windowCache self)
      (setf (windowCache self) (upper self Window))))

;;;(defmacro wd ()
;;;  `(or (windowCache self)
;;;     (setf (windowCache self) (upper self Window))))

(defmacro swdw () '.w.)

(defmacro with-glutw ((wform) &body body)
  (let ((w (gensym))(oldw (gensym)))
    `(let ((,w ,wform)
           (,oldw (glut-get-window)))
       (if (eql (glutw ,w) ,oldw)
           (setf ,oldw nil)
         (glut-set-window (glutw ,w)))
       (prog1
           (progn ,@body)
         (when ,oldw
           (glut-set-window ,oldw))))))

(defmacro with-clipping ((self-form) &body body)
  (let ((fn (gensym)))
    `(let ((,fn (lambda () ,@body)))
       (declare (dynamic-extent ,fn))
       (call-with-clipping ,self-form ,fn))))



(defparameter *timeMe* nil)

(defparameter *hlt* nil)
(defparameter *hs* nil)

(defparameter *with-invalidation* nil)
(defparameter *with-one-invalidation* nil)
(defparameter *wm-paint-stack* nil)
(defparameter *wm-paint-reentrant* nil)



