(in-package :cello)

(defmethod ix-render :around ((self Window))
    #+nahhh (fm-traverse self (lambda (ix)
                      (when (typep ix 'Image)
                        (c-assert (<= (lL ix) (lR ix))() "bad ix ~a ll,lr" ix)
                        (c-assert (<= (lB ix) (lT ix))() "bad ix ~a lt,lb" ix)))
    :global-search nil)
  (trc nil "ix-render window" self)
  (flet (
         (projection ()
           (gl-matrix-mode GL_PROJECTION)
           (gl-Load-Identity)
           (trc nil "ixrender ortho window:"
             (lL self)(lR self)
             (lB self)(lT self)
             *mgw-znear* *mgw-zfar*)
           (gl-Ortho (lL self)
             (lR self) (lB self)
             (lT self)
             *mgw-znear*
             *mgw-zfar*
             ))
         (lighting ()
           (when (eql :on (lighting self))
             (gl-Enable GL_LIGHTING)
             (gl-light-modelfv GL_LIGHT_MODEL_AMBIENT *blackout*)
             (gl-Enable GL_COLOR_MATERIAL)
             ;;; 
             (dolist (l (lights self))
               (light-install l))
           
             (gl-enable GL_NORMALIZE)
           ))
         )
    (projection)
    (gl-matrix-mode GL_MODELVIEW)
    (gl-Load-Identity)
    (lighting)
    (gl-Clear (+ GL_COLOR_BUFFER_BIT GL_DEPTH_BUFFER_BIT))
    #+shh (macrolet ((glm (param num)
                        (declare (ignore num))
                        `(trc ,(symbol-name param) (cello-get-int ,param))))
             (glm GL_MAX_EVAL_ORDER			#x3376 ) 	
             (glm GL_MAX_LIGHTS			#x3377 ) 	
             (glm GL_MAX_CLIP_PLANES			#x3378 ) 	
             (glm GL_MAX_TEXTURE_SIZE 		#x3379 ) 	
             (glm GL_MAX_PIXEL_MAP_TABLE		#x3380 ) 	
             (glm GL_MAX_ATTRIB_STACK_DEPTH	#x3381 ) 	
             (glm GL_MAX_MODELVIEW_STACK_DEPTH	#x3382 ) 	
             (glm GL_MAX_NAME_STACK_DEPTH		#x3383 ) 	
             (glm GL_MAX_PROJECTION_STACK_DEPTH 	#x3384 ) 	
             (glm GL_MAX_TEXTURE_STACK_DEPTH 	#x3385 ) 	
             (glm GL_MAX_VIEWPORT_DIMS 		#x3386 )
             )
    (call-next-method)
    ))





