;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright (c) 1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.


(in-package :cello)


(defmodel edt-window (Window)
    ()
    (:default-initargs
        :title$ "EDT"
      :lighting :off
      :layers (list +white+ :fill-lr)
      :kids (c? 
              (theKids
                 (aLabel "Hello, New Yawk!!"
                     :px 0 :py 0
                     :layers (list +blue+ :fill-lr +red+)
                     :lighting :off
                     )
               #+not (aStack ( :px 0 ;;(c? (floor (lwidth .parent.) 2))
                               :py 0
                               ;;:lighting :off
                               ;:layers (list +white+ :fill-lr)
                               )
                       (aLabel "Hello, New Yawk!!"
                         :px 0 :py 0
                         ;;:layers +black+
                         ;;:lighting :off
                         ))))))

;; ACL project manager init function run on control-shift-R
(defun test-edt ()
  (let ((cells::*dfdbg* nil))
    (run-window (make-instance 'edt-window))))




(defmethod make-os-font ((w edt-window) (font-key (eql :default)))
  (with-glutw (w)
    (eko (nil "made font for default" w)
      (uffi:with-cstring (n "Sylfaen")
        (make-font-os
         :fPtr (let ((fptr (glut-os-font-make n 0 36 FW_NORMAL
                             0 0 0 0.0 0.0 wgl_font_polygons)))
                 (unless (plusp (ff-pointer-address fptr))
                   (trc ":font-make-failed" fptr)
                   (cellbrk :font-make-failed))
                 fptr))))))