;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cello; -*-
;;;
;;; Copyright (c) 1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.


(in-package :cello)


(defmodel struct-slots-view (IXStack)
  ()
  (:default-initargs
      
    :kids (list (aStack (:lR (c? (^fill-right window)))
                  (make-slider :htabs
                      :height (upts 8)
                      :width (lwidth self)
                      :initial-pcts (list (mkv2 0 0) (mkv2 0.3 0)))
                  (mkpart :bb (IXText) :text$ "---")
                  (mkPart :structslots (CTStructSlotStack))))))

(defmethod instance-slot-name ((self EXCL::STRUCTURE-EFFECTIVE-SLOT-DEFINITION))
  (slot-value self 'excl::name))

(defun instance-slot-value (self name)
  (slot-value self name))

(defmodel CTStructSlotStack (CTSlotStack)
  ()
  (:default-initargs
      :visible (c? (visible (upper self struct-slots-view)))
    :slots (c? (eko (nil "structure slots")
                 (when (^visible)
                   (bwhen (tgt (target .inspection.)) ;; should be if visible
                     (sort (copy-list (instance-slots tgt))
                       #'string< :key #'instance-slot-name)))))
    :max-slot-count (c? (max (or .cache 0) (length (^slots))))
    :kidvalues (c? (loop for n below (^max-slot-count) collect n))
    :kvkey #'md-value
    :kidfactory (lambda (slot-stack slot-no)
                  (declare (ignorable slot-stack))
                  (cells::make-part (gensym "STRUCTSLOT") 'slot-inspector
                    :slot-no slot-no
                    :Px (U8THS 1)
                    :pY (+ -14 (* slot-no (upts -21)))
                    :slot-name (c? (bwhen (sdef (^slot-def))
                                     (instance-slot-name sdef)))
                    :si-value (c? (bwhen (sdef (^slot-def))
                                    (instance-slot-value (target .inspection.)
                                      (instance-slot-name sdef))))))))


