;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cl-user; -*-

(in-package :cl-user)

(defun build-sys (force device &rest path 
                   &aux
                   (system$ (car (last path)))
                   (source-directory (make-pathname #+lispworks :host #-lispworks :device device
                                                    :directory `(:absolute ,@path))))
  (let (
        #+cmu18
        (ext:*derive-function-types* nil)
        
        #+lispworks
        (hcl::*handle-existing-defpackage* (list :add))
	)

    ;;----------------------------------------
    ;; source-directory validation...
    ;;
    (assert (pathnamep source-directory)
	    (source-directory)
	    "SOURCE-DIRECTORY not supplied, please edit build.lisp to specify the location of the source.")
  (let ((project-asd (merge-pathnames (format nil "~a.asd" system$)
                         source-directory)))
      (if (probe-file project-asd)
          (format t "Proceeding with ASD file ~a" (probe-file project-asd))
        (error "~a not found. Revise BUILD.LISP if ASD file is somewhere else." project-asd)))
    
    ;;;----------------------------------
    ;;; ok. build...
    ;;;
    (push source-directory asdf:*central-registry*)
    (asdf:operate 'asdf:load-op (intern system$ :keyword) :force force)))