;;;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10 -*-

;(declaim (optimize (debug 2) (speed 1) (safety 1) (compilation-speed 1)))
(declaim (optimize (debug 3) (speed 3) (safety 1) (compilation-speed 0)))


#+(or allegro lispworks cmu mcl clisp cormanlisp sbcl scl)

(asdf:defsystem :cells
  :name "cells"
  :author "Kenny Tilton <ktilton@nyc.rr.com>"
  :version "05-Nov-2003"
  :maintainer "Kenny Tilton <ktilton@nyc.rr.com>"
  :licence "MIT Style"
  :description "Cells"
  :long-description "The Cells dataflow extension to CLOS."
  :components
  ((:file "cells")
   (:file "flow-control" :depends-on ("cells"))
   (:file "strings" :depends-on ("flow-control"))
   (:file "detritus" :depends-on ("flow-control"))
   (:file "cell-types" :depends-on ("cells"))
   (:file "debug" :depends-on ("cell-types"))
   (:file "initialize" :depends-on ("debug"))
   (:file "dataflow-management" :depends-on ("debug"))
   (:file "md-slot-value" :depends-on ("debug"))
   (:file "calc-n-set" :depends-on ("debug"))
   (:file "slot-utilities" :depends-on ("debug"))
   (:file "optimization" :depends-on ("debug"))
   (:file "link" :depends-on ("debug"))
   (:file "propagate" :depends-on ("debug"))
   (:file "synapse" :depends-on ("debug" "cell-types"))
   (:file "model-object" :depends-on ("debug"))
   (:file "defmodel" :depends-on ("model-object"))
   (:file "md-utilities" :depends-on ("defmodel"))
   (:file "family" :depends-on ("propagate" "model-object" "defmodel"))
   (:file "fm-utilities" :depends-on ("family"))
   (:file "family-values" :depends-on ("flow-control" "fm-utilities"))))

(defmethod asdf:perform ((o load-op) (c (eql (find-system :cells))))
  (pushnew "CELLS" *modules*)
  (pushnew :cells *features*))