;; -*- mode: Lisp; Syntax: Common-Lisp; Package: ogb; -*-
;;;
;;; Copyright  1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package #:ogb)

#| BlendingFactorDest |#
(dfc GL_ZERO                           0)
(dfc GL_ONE                            1)
(dfc GL_SRC_COLOR                      #x0300)
(dfc GL_ONE_MINUS_SRC_COLOR            #x0301)
(dfc GL_SRC_ALPHA                      #x0302)
(dfc GL_ONE_MINUS_SRC_ALPHA            #x0303)
(dfc GL_DST_ALPHA                      #x0304)
(dfc GL_ONE_MINUS_DST_ALPHA            #x0305)

#| PixelCopyType |#
(dfc GL_COLOR                          #x1800)
(dfc GL_DEPTH                          #x1801)
(dfc GL_STENCIL                        #x1802)

#| PixelFormat |#
(dfc GL_COLOR_INDEX                    #x1900)
(dfc GL_STENCIL_INDEX                  #x1901)
(dfc GL_DEPTH_COMPONENT                #x1902)
(dfc GL_RED                            #x1903)
(dfc GL_GREEN                          #x1904)
(dfc GL_BLUE                           #x1905)
(dfc GL_ALPHA                          #x1906)
(dfc GL_RGB                            #x1907)
(dfc GL_RGBA                           #x1908)
(dfc GL_LUMINANCE                      #x1909)
(dfc GL_LUMINANCE_ALPHA                #x190A)

#| Polygons |#
(dfc GL_POINT                                #x1B00)
(dfc GL_LINE                                 #x1B01)
(dfc GL_FILL                                 #x1B02)
(dfc GL_CW                                   #x0900)
(dfc GL_CCW                                  #x0901)
(dfc GL_FRONT                                #x0404)
(dfc GL_BACK                                 #x0405)
(dfc GL_POLYGON_OFFSET_FACTOR                #x8038)
(dfc GL_POLYGON_OFFSET_UNITS                 #x2A00)
(dfc GL_POLYGON_OFFSET_POINT                 #x2A01)
(dfc GL_POLYGON_OFFSET_LINE                  #x2A02)
(dfc GL_POLYGON_OFFSET_FILL                  #x8037)

#| Lighting |#

(dfc GL_LIGHT0                               #x4000)
(dfc GL_LIGHT1                               #x4001)
(dfc GL_LIGHT2                               #x4002)
(dfc GL_LIGHT3                               #x4003)
(dfc GL_LIGHT4                               #x4004)
(dfc GL_LIGHT5                               #x4005)
(dfc GL_LIGHT6                               #x4006)
(dfc GL_LIGHT7                               #x4007)
(dfc GL_SPOT_EXPONENT                        #x1205)
(dfc GL_SPOT_CUTOFF                          #x1206)
(dfc GL_CONSTANT_ATTENUATION                 #x1207)
(dfc GL_LINEAR_ATTENUATION                   #x1208)
(dfc GL_QUADRATIC_ATTENUATION                #x1209)
(dfc GL_AMBIENT                              #x1200)
(dfc GL_DIFFUSE                              #x1201)
(dfc GL_SPECULAR                             #x1202)
(dfc GL_SHININESS                            #x1601)
(dfc GL_EMISSION                             #x1600)
(dfc GL_POSITION                             #x1203)
(dfc GL_SPOT_DIRECTION                       #x1204)
(dfc GL_AMBIENT_AND_DIFFUSE                  #x1602)
(dfc GL_COLOR_INDEXES                        #x1603)
(dfc GL_FRONT_AND_BACK                       #x0408)
(dfc GL_FLAT                                 #x1D00)
(dfc GL_SMOOTH                               #x1D01)

#| User clipping planes |#
(dfc GL_CLIP_PLANE0                          #x3000)
(dfc GL_CLIP_PLANE1                          #x3001)
(dfc GL_CLIP_PLANE2                          #x3002)
(dfc GL_CLIP_PLANE3                          #x3003)
(dfc GL_CLIP_PLANE4                          #x3004)
(dfc GL_CLIP_PLANE5                          #x3005)

#| Boolean values |#
(dfc GL_FALSE                                #x0)
(dfc GL_TRUE                                 #x1)

#| Data types |#
(dfc GL_BYTE                                 #x1400)
(dfc GL_UNSIGNED_BYTE                        #x1401)
(dfc GL_SHORT                                #x1402)
(dfc GL_UNSIGNED_SHORT                       #x1403)
(dfc GL_INT                                  #x1404)
(dfc GL_UNSIGNED_INT                         #x1405)
(dfc GL_FLOAT                                #x1406)
(dfc GL_DOUBLE                               #x140A)
(dfc GL_2_BYTES                              #x1407)
(dfc GL_3_BYTES                              #x1408)
(dfc GL_4_BYTES                              #x1409)

#| Primitives |#
(dfc GL_POINTS                               #x0000)
(dfc GL_LINES                                #x0001)
(dfc GL_LINE_LOOP                            #x0002)
(dfc GL_LINE_STRIP                           #x0003)
(dfc GL_TRIANGLES                            #x0004)
(dfc GL_TRIANGLE_STRIP                       #x0005)
(dfc GL_TRIANGLE_FAN                         #x0006)
(dfc GL_QUADS                                #x0007)
(dfc GL_QUAD_STRIP                           #x0008)
(dfc GL_POLYGON                              #x0009)

#| Vertex Arrays |#
(dfc GL_VERTEX_ARRAY                         #x8074)
(dfc GL_NORMAL_ARRAY                         #x8075)
(dfc GL_COLOR_ARRAY                          #x8076)
(dfc GL_INDEX_ARRAY                          #x8077)
(dfc GL_TEXTURE_COORD_ARRAY                  #x8078)
(dfc GL_EDGE_FLAG_ARRAY                      #x8079)
(dfc GL_VERTEX_ARRAY_SIZE                    #x807A)
(dfc GL_VERTEX_ARRAY_TYPE                    #x807B)
(dfc GL_VERTEX_ARRAY_STRIDE                  #x807C)
(dfc GL_NORMAL_ARRAY_TYPE                    #x807E)
(dfc GL_NORMAL_ARRAY_STRIDE                  #x807F)
(dfc GL_COLOR_ARRAY_SIZE                     #x8081)
(dfc GL_COLOR_ARRAY_TYPE                     #x8082)
(dfc GL_COLOR_ARRAY_STRIDE                   #x8083)
(dfc GL_INDEX_ARRAY_TYPE                     #x8085)
(dfc GL_INDEX_ARRAY_STRIDE                   #x8086)
(dfc GL_TEXTURE_COORD_ARRAY_SIZE             #x8088)
(dfc GL_TEXTURE_COORD_ARRAY_TYPE             #x8089)
(dfc GL_TEXTURE_COORD_ARRAY_STRIDE           #x808A)
(dfc GL_EDGE_FLAG_ARRAY_STRIDE               #x808C)
(dfc GL_VERTEX_ARRAY_POINTER                 #x808E)
(dfc GL_NORMAL_ARRAY_POINTER                 #x808F)
(dfc GL_COLOR_ARRAY_POINTER                  #x8090)
(dfc GL_INDEX_ARRAY_POINTER                  #x8091)
(dfc GL_TEXTURE_COORD_ARRAY_POINTER          #x8092)
(dfc GL_EDGE_FLAG_ARRAY_POINTER              #x8093)
(dfc GL_V2F                                  #x2A20)
(dfc GL_V3F                                  #x2A21)
(dfc GL_C4UB_V2F                             #x2A22)
(dfc GL_C4UB_V3F                             #x2A23)
(dfc GL_C3F_V3F                              #x2A24)
(dfc GL_N3F_V3F                              #x2A25)
(dfc GL_C4F_N3F_V3F                          #x2A26)
(dfc GL_T2F_V3F                              #x2A27)
(dfc GL_T4F_V4F                              #x2A28)
(dfc GL_T2F_C4UB_V3F                         #x2A29)
(dfc GL_T2F_C3F_V3F                          #x2A2A)
(dfc GL_T2F_N3F_V3F                          #x2A2B)
(dfc GL_T2F_C4F_N3F_V3F                      #x2A2C)
(dfc GL_T4F_C4F_N3F_V4F                      #x2A2D)

#| Matrix Mode |#
(dfc GL_MODELVIEW                            #x1700)
(dfc GL_PROJECTION                           #x1701)
(dfc GL_TEXTURE                              #x1702)

#| Display Lists |#
(dfc GL_COMPILE                              #x1300)
(dfc GL_COMPILE_AND_EXECUTE                  #x1301)

#| Depth buffer |#
(dfc GL_NEVER                                #x0200)
(dfc GL_LESS                                 #x0201)
(dfc GL_EQUAL                                #x0202)
(dfc GL_LEQUAL                               #x0203)
(dfc GL_GREATER                              #x0204)
(dfc GL_NOTEQUAL                             #x0205)
(dfc GL_GEQUAL                               #x0206)
(dfc GL_ALWAYS                               #x0207)


#| Texture mapping |#
(dfc GL_TEXTURE_ENV                          #x2300)
(dfc GL_TEXTURE_ENV_MODE                     #x2200)
(dfc GL_TEXTURE_WRAP_S                       #x2802)
(dfc GL_TEXTURE_WRAP_T                       #x2803)
(dfc GL_TEXTURE_MAG_FILTER                   #x2800)
(dfc GL_TEXTURE_MIN_FILTER                   #x2801)
(dfc GL_TEXTURE_ENV_COLOR                    #x2201)
(dfc GL_TEXTURE_GEN_MODE                     #x2500)
(dfc GL_TEXTURE_BORDER_COLOR                 #x1004)
(dfc GL_TEXTURE_WIDTH                        #x1000)
(dfc GL_TEXTURE_HEIGHT                       #x1001)
(dfc GL_TEXTURE_BORDER                       #x1005)
(dfc GL_TEXTURE_COMPONENTS                   #x1003)
(dfc GL_TEXTURE_RED_SIZE                     #x805C)
(dfc GL_TEXTURE_GREEN_SIZE                   #x805D)
(dfc GL_TEXTURE_BLUE_SIZE                    #x805E)
(dfc GL_TEXTURE_ALPHA_SIZE                   #x805F)
(dfc GL_TEXTURE_LUMINANCE_SIZE               #x8060)
(dfc GL_TEXTURE_INTENSITY_SIZE               #x8061)
(dfc GL_NEAREST_MIPMAP_NEAREST               #x2700)
(dfc GL_NEAREST_MIPMAP_LINEAR                #x2702)
(dfc GL_LINEAR_MIPMAP_NEAREST                #x2701)
(dfc GL_LINEAR_MIPMAP_LINEAR                 #x2703)
(dfc GL_OBJECT_LINEAR                        #x2401)
(dfc GL_OBJECT_PLANE                         #x2501)
(dfc GL_EYE_LINEAR                           #x2400)
(dfc GL_EYE_PLANE                            #x2502)
(dfc GL_SPHERE_MAP                           #x2402)
(dfc GL_DECAL                                #x2101)
(dfc GL_MODULATE                             #x2100)
(dfc GL_NEAREST                              #x2600)
(dfc GL_LINEAR                               #x2601)

(dfc GL_REPEAT                               #x2901)
(dfc GL_CLAMP                                #x2900)
(dfc GL_S                                    #x2000)
(dfc GL_T                                    #x2001)
(dfc GL_R                                    #x2002)
(dfc GL_Q                                    #x2003)

#| Utility |#
(dfc GL_VENDOR                               #x1F00)
(dfc GL_RENDERER                             #x1F01)
(dfc GL_VERSION                              #x1F02)
(dfc GL_EXTENSIONS                           #x1F03)

#| Errors |#
(dfc GL_NO_ERROR                             #x0)
(dfc GL_INVALID_VALUE                        #x0501)
(dfc GL_INVALID_ENUM                         #x0500)
(dfc GL_INVALID_OPERATION                    #x0502)
(dfc GL_STACK_OVERFLOW                       #x0503)
(dfc GL_STACK_UNDERFLOW                      #x0504)
(dfc GL_OUT_OF_MEMORY                        #x0505)


#| glPush/PopAttrib bits |#
(dfc GL_CURRENT_BIT                          #x00000001)
(dfc GL_POINT_BIT                            #x00000002)
(dfc GL_LINE_BIT                             #x00000004)
(dfc GL_POLYGON_BIT                          #x00000008)
(dfc GL_POLYGON_STIPPLE_BIT                  #x00000010)
(dfc GL_PIXEL_MODE_BIT                       #x00000020)
(dfc GL_LIGHTING_BIT                         #x00000040)
(dfc GL_FOG_BIT                              #x00000080)
(dfc GL_DEPTH_BUFFER_BIT                     #x00000100)
(dfc GL_ACCUM_BUFFER_BIT                     #x00000200)
(dfc GL_STENCIL_BUFFER_BIT                   #x00000400)
(dfc GL_VIEWPORT_BIT                         #x00000800)
(dfc GL_TRANSFORM_BIT                        #x00001000)
(dfc GL_ENABLE_BIT                           #x00002000)
(dfc GL_COLOR_BUFFER_BIT                     #x00004000)
(dfc GL_HINT_BIT                             #x00008000)
(dfc GL_EVAL_BIT                             #x00010000)
(dfc GL_LIST_BIT                             #x00020000)
(dfc GL_TEXTURE_BIT                          #x00040000)
(dfc GL_SCISSOR_BIT                          #x00080000)
(dfc GL_ALL_ATTRIB_BITS                      #x000FFFFF)


#| Gets |#
(dfc GL_CURRENT_COLOR                  #x0B00)
(dfc GL_CURRENT_INDEX                  #x0B01)
(dfc GL_CURRENT_NORMAL                 #x0B02)
(dfc GL_CURRENT_TEXTURE_COORDS         #x0B03)
(dfc GL_CURRENT_RASTER_COLOR           #x0B04)
(dfc GL_CURRENT_RASTER_INDEX           #x0B05)
(dfc GL_CURRENT_RASTER_TEXTURE_COORDS  #x0B06)
(dfc GL_CURRENT_RASTER_POSITION        #x0B07)
(dfc GL_CURRENT_RASTER_POSITION_VALID  #x0B08)
(dfc GL_CURRENT_RASTER_DISTANCE        #x0B09)
(dfc GL_POINT_SMOOTH                   #x0B10)
(dfc GL_POINT_SIZE                     #x0B11)
(dfc GL_POINT_SIZE_RANGE               #x0B12)
(dfc GL_POINT_SIZE_GRANULARITY         #x0B13)
(dfc GL_LINE_SMOOTH                    #x0B20)
(dfc GL_LINE_WIDTH                     #x0B21)
(dfc GL_LINE_WIDTH_RANGE               #x0B22)
(dfc GL_LINE_WIDTH_GRANULARITY         #x0B23)
(dfc GL_LINE_STIPPLE                   #x0B24)
(dfc GL_LINE_STIPPLE_PATTERN           #x0B25)
(dfc GL_LINE_STIPPLE_REPEAT            #x0B26)
(dfc GL_LIST_MODE                      #x0B30)
(dfc GL_MAX_LIST_NESTING               #x0B31)
(dfc GL_LIST_BASE                      #x0B32)
(dfc GL_LIST_INDEX                     #x0B33)
(dfc GL_POLYGON_MODE                   #x0B40)
(dfc GL_POLYGON_SMOOTH                 #x0B41)
(dfc GL_POLYGON_STIPPLE                #x0B42)
(dfc GL_EDGE_FLAG                      #x0B43)
(dfc GL_CULL_FACE                      #x0B44)
(dfc GL_CULL_FACE_MODE                 #x0B45)
(dfc GL_FRONT_FACE                     #x0B46)
(dfc GL_LIGHTING                       #x0B50)
(dfc GL_LIGHT_MODEL_LOCAL_VIEWER       #x0B51)
(dfc GL_LIGHT_MODEL_TWO_SIDE           #x0B52)
(dfc GL_LIGHT_MODEL_AMBIENT            #x0B53)
(dfc GL_SHADE_MODEL                    #x0B54)
(dfc GL_COLOR_MATERIAL_FACE            #x0B55)
(dfc GL_COLOR_MATERIAL_PARAMETER       #x0B56)
(dfc GL_COLOR_MATERIAL                 #x0B57)
(dfc GL_FOG                            #x0B60)
(dfc GL_FOG_INDEX                      #x0B61)
(dfc GL_FOG_DENSITY                    #x0B62)
(dfc GL_FOG_START                      #x0B63)
(dfc GL_FOG_END                        #x0B64)
(dfc GL_FOG_MODE                       #x0B65)
(dfc GL_FOG_COLOR                      #x0B66)
(dfc GL_DEPTH_RANGE                    #x0B70)
(dfc GL_DEPTH_TEST                     #x0B71)
(dfc GL_DEPTH_WRITEMASK                #x0B72)
(dfc GL_DEPTH_CLEAR_VALUE              #x0B73)
(dfc GL_DEPTH_FUNC                     #x0B74)
(dfc GL_ACCUM_CLEAR_VALUE              #x0B80)
(dfc GL_STENCIL_TEST                   #x0B90)
(dfc GL_STENCIL_CLEAR_VALUE            #x0B91)
(dfc GL_STENCIL_FUNC                   #x0B92)
(dfc GL_STENCIL_VALUE_MASK             #x0B93)
(dfc GL_STENCIL_FAIL                   #x0B94)
(dfc GL_STENCIL_PASS_DEPTH_FAIL        #x0B95)
(dfc GL_STENCIL_PASS_DEPTH_PASS        #x0B96)
(dfc GL_STENCIL_REF                    #x0B97)
(dfc GL_STENCIL_WRITEMASK              #x0B98)
(dfc GL_MATRIX_MODE                    #x0BA0)
(dfc GL_NORMALIZE                      #x0BA1)
(dfc GL_VIEWPORT                       #x0BA2)
(dfc GL_MODELVIEW_STACK_DEPTH          #x0BA3)
(dfc GL_PROJECTION_STACK_DEPTH         #x0BA4)
(dfc GL_TEXTURE_STACK_DEPTH            #x0BA5)
(dfc GL_MODELVIEW_MATRIX               #x0BA6)
(dfc GL_PROJECTION_MATRIX              #x0BA7)
(dfc GL_TEXTURE_MATRIX                 #x0BA8)
(dfc GL_ATTRIB_STACK_DEPTH             #x0BB0)
(dfc GL_CLIENT_ATTRIB_STACK_DEPTH      #x0BB1)
(dfc GL_ALPHA_TEST                     #x0BC0)
(dfc GL_ALPHA_TEST_FUNC                #x0BC1)
(dfc GL_ALPHA_TEST_REF                 #x0BC2)
(dfc GL_DITHER                         #x0BD0)
(dfc GL_BLEND_DST                      #x0BE0)
(dfc GL_BLEND_SRC                      #x0BE1)
(dfc GL_BLEND                          #x0BE2)
(dfc GL_LOGIC_OP_MODE                  #x0BF0)
(dfc GL_INDEX_LOGIC_OP                 #x0BF1)
(dfc GL_COLOR_LOGIC_OP                 #x0BF2)
(dfc GL_AUX_BUFFERS                    #x0C00)
(dfc GL_DRAW_BUFFER                    #x0C01)
(dfc GL_READ_BUFFER                    #x0C02)
(dfc GL_SCISSOR_BOX                    #x0C10)
(dfc GL_SCISSOR_TEST                   #x0C11)
(dfc GL_INDEX_CLEAR_VALUE              #x0C20)
(dfc GL_INDEX_WRITEMASK                #x0C21)
(dfc GL_COLOR_CLEAR_VALUE              #x0C22)
(dfc GL_COLOR_WRITEMASK                #x0C23)
(dfc GL_INDEX_MODE                     #x0C30)
(dfc GL_RGBA_MODE                      #x0C31)
(dfc GL_DOUBLEBUFFER                   #x0C32)
(dfc GL_STEREO                         #x0C33)
(dfc GL_RENDER_MODE                    #x0C40)
(dfc GL_PERSPECTIVE_CORRECTION_HINT    #x0C50)
(dfc GL_POINT_SMOOTH_HINT              #x0C51)
(dfc GL_LINE_SMOOTH_HINT               #x0C52)
(dfc GL_POLYGON_SMOOTH_HINT            #x0C53)
(dfc GL_FOG_HINT                       #x0C54)
(dfc GL_TEXTURE_GEN_S                  #x0C60)
(dfc GL_TEXTURE_GEN_T                  #x0C61)
(dfc GL_TEXTURE_GEN_R                  #x0C62)
(dfc GL_TEXTURE_GEN_Q                  #x0C63)
(dfc GL_PIXEL_MAP_I_TO_I               #x0C70)
(dfc GL_PIXEL_MAP_S_TO_S               #x0C71)
(dfc GL_PIXEL_MAP_I_TO_R               #x0C72)
(dfc GL_PIXEL_MAP_I_TO_G               #x0C73)
(dfc GL_PIXEL_MAP_I_TO_B               #x0C74)
(dfc GL_PIXEL_MAP_I_TO_A               #x0C75)
(dfc GL_PIXEL_MAP_R_TO_R               #x0C76)
(dfc GL_PIXEL_MAP_G_TO_G               #x0C77)
(dfc GL_PIXEL_MAP_B_TO_B               #x0C78)
(dfc GL_PIXEL_MAP_A_TO_A               #x0C79)
(dfc GL_PIXEL_MAP_I_TO_I_SIZE          #x0CB0)
(dfc GL_PIXEL_MAP_S_TO_S_SIZE          #x0CB1)
(dfc GL_PIXEL_MAP_I_TO_R_SIZE          #x0CB2)
(dfc GL_PIXEL_MAP_I_TO_G_SIZE          #x0CB3)
(dfc GL_PIXEL_MAP_I_TO_B_SIZE          #x0CB4)
(dfc GL_PIXEL_MAP_I_TO_A_SIZE          #x0CB5)
(dfc GL_PIXEL_MAP_R_TO_R_SIZE          #x0CB6)
(dfc GL_PIXEL_MAP_G_TO_G_SIZE          #x0CB7)
(dfc GL_PIXEL_MAP_B_TO_B_SIZE          #x0CB8)
(dfc GL_PIXEL_MAP_A_TO_A_SIZE          #x0CB9)
(dfc GL_UNPACK_SWAP_BYTES              #x0CF0)
(dfc GL_UNPACK_LSB_FIRST               #x0CF1)
(dfc GL_UNPACK_ROW_LENGTH              #x0CF2)
(dfc GL_UNPACK_SKIP_ROWS               #x0CF3)
(dfc GL_UNPACK_SKIP_PIXELS             #x0CF4)
(dfc GL_UNPACK_ALIGNMENT               #x0CF5)
(dfc GL_PACK_SWAP_BYTES                #x0D00)
(dfc GL_PACK_LSB_FIRST                 #x0D01)
(dfc GL_PACK_ROW_LENGTH                #x0D02)
(dfc GL_PACK_SKIP_ROWS                 #x0D03)
(dfc GL_PACK_SKIP_PIXELS               #x0D04)
(dfc GL_PACK_ALIGNMENT                 #x0D05)
(dfc GL_MAP_COLOR                      #x0D10)
(dfc GL_MAP_STENCIL                    #x0D11)
(dfc GL_INDEX_SHIFT                    #x0D12)
(dfc GL_INDEX_OFFSET                   #x0D13)
(dfc GL_RED_SCALE                      #x0D14)
(dfc GL_RED_BIAS                       #x0D15)
(dfc GL_ZOOM_X                         #x0D16)
(dfc GL_ZOOM_Y                         #x0D17)
(dfc GL_GREEN_SCALE                    #x0D18)
(dfc GL_GREEN_BIAS                     #x0D19)
(dfc GL_BLUE_SCALE                     #x0D1A)
(dfc GL_BLUE_BIAS                      #x0D1B)
(dfc GL_ALPHA_SCALE                    #x0D1C)
(dfc GL_ALPHA_BIAS                     #x0D1D)
(dfc GL_DEPTH_SCALE                    #x0D1E)
(dfc GL_DEPTH_BIAS                     #x0D1F)
(dfc GL_MAX_EVAL_ORDER                 #x0D30)
(dfc GL_MAX_LIGHTS                     #x0D31)
(dfc GL_MAX_CLIP_PLANES                #x0D32)
(dfc GL_MAX_TEXTURE_SIZE               #x0D33)
(dfc GL_MAX_PIXEL_MAP_TABLE            #x0D34)
(dfc GL_MAX_ATTRIB_STACK_DEPTH         #x0D35)
(dfc GL_MAX_MODELVIEW_STACK_DEPTH      #x0D36)
(dfc GL_MAX_NAME_STACK_DEPTH           #x0D37)
(dfc GL_MAX_PROJECTION_STACK_DEPTH     #x0D38)
(dfc GL_MAX_TEXTURE_STACK_DEPTH        #x0D39)
(dfc GL_MAX_VIEWPORT_DIMS              #x0D3A)
(dfc GL_MAX_CLIENT_ATTRIB_STACK_DEPTH  #x0D3B)
(dfc GL_SUBPIXEL_BITS                  #x0D50)
(dfc GL_INDEX_BITS                     #x0D51)
(dfc GL_RED_BITS                       #x0D52)
(dfc GL_GREEN_BITS                     #x0D53)
(dfc GL_BLUE_BITS                      #x0D54)
(dfc GL_ALPHA_BITS                     #x0D55)
(dfc GL_DEPTH_BITS                     #x0D56)
(dfc GL_STENCIL_BITS                   #x0D57)
(dfc GL_ACCUM_RED_BITS                 #x0D58)
(dfc GL_ACCUM_GREEN_BITS               #x0D59)
(dfc GL_ACCUM_BLUE_BITS                #x0D5A)
(dfc GL_ACCUM_ALPHA_BITS               #x0D5B)
(dfc GL_NAME_STACK_DEPTH               #x0D70)
(dfc GL_AUTO_NORMAL                    #x0D80)
(dfc GL_MAP1_COLOR_4                   #x0D90)
(dfc GL_MAP1_INDEX                     #x0D91)
(dfc GL_MAP1_NORMAL                    #x0D92)
(dfc GL_MAP1_TEXTURE_COORD_1           #x0D93)
(dfc GL_MAP1_TEXTURE_COORD_2           #x0D94)
(dfc GL_MAP1_TEXTURE_COORD_3           #x0D95)
(dfc GL_MAP1_TEXTURE_COORD_4           #x0D96)
(dfc GL_MAP1_VERTEX_3                  #x0D97)
(dfc GL_MAP1_VERTEX_4                  #x0D98)
(dfc GL_MAP2_COLOR_4                   #x0DB0)
(dfc GL_MAP2_INDEX                     #x0DB1)
(dfc GL_MAP2_NORMAL                    #x0DB2)
(dfc GL_MAP2_TEXTURE_COORD_1           #x0DB3)
(dfc GL_MAP2_TEXTURE_COORD_2           #x0DB4)
(dfc GL_MAP2_TEXTURE_COORD_3           #x0DB5)
(dfc GL_MAP2_TEXTURE_COORD_4           #x0DB6)
(dfc GL_MAP2_VERTEX_3                  #x0DB7)
(dfc GL_MAP2_VERTEX_4                  #x0DB8)
(dfc GL_MAP1_GRID_DOMAIN               #x0DD0)
(dfc GL_MAP1_GRID_SEGMENTS             #x0DD1)
(dfc GL_MAP2_GRID_DOMAIN               #x0DD2)
(dfc GL_MAP2_GRID_SEGMENTS             #x0DD3)
(dfc GL_TEXTURE_1D                     #x0DE0)
(dfc GL_TEXTURE_2D                     #x0DE1)
(dfc GL_FEEDBACK_BUFFER_POINTER        #x0DF0)
(dfc GL_FEEDBACK_BUFFER_SIZE           #x0DF1)
(dfc GL_FEEDBACK_BUFFER_TYPE           #x0DF2)
(dfc GL_SELECTION_BUFFER_POINTER       #x0DF3)
(dfc GL_SELECTION_BUFFER_SIZE          #x0DF4)


#| Render Mode |#
(dfc GL_FEEDBACK                             #x1C01)
(dfc GL_RENDER                               #x1C00)
(dfc GL_SELECT                               #x1C02)


#| Hints |#
(dfc GL_DONT_CARE                            #x1100)
(dfc GL_FASTEST                              #x1101)
(dfc GL_NICEST                               #x1102)

;;;#| max stuff |#
;;;
;;;(dfc GL_MAX_EVAL_ORDER			3376 ) 	
;;;(dfc GL_MAX_LIGHTS			3377 ) 	
;;;(dfc GL_MAX_CLIP_PLANES			3378 ) 	
;;;(dfc GL_MAX_TEXTURE_SIZE 		3379 ) 	
;;;(dfc GL_MAX_PIXEL_MAP_TABLE		3380 ) 	
;;;(dfc GL_MAX_ATTRIB_STACK_DEPTH	3381 ) 	
;;;(dfc GL_MAX_MODELVIEW_STACK_DEPTH	3382 ) 	
;;;(dfc GL_MAX_NAME_STACK_DEPTH		3383 ) 	
;;;(dfc GL_MAX_PROJECTION_STACK_DEPTH 	3384 ) 	
;;;(dfc GL_MAX_TEXTURE_STACK_DEPTH 	3385 ) 	
;;;(dfc GL_MAX_VIEWPORT_DIMS 		3386 ) 	
