;; -*- mode: Lisp; Syntax: Common-Lisp; Package: ogb; -*-
;;;
;;; Copyright  1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package #:opengl-bindings)


(defun-ogb :void "OPENGL32" "glFlush" ())


(defun-ogb :void "OPENGL32" "glMaterialfv" (GLenum face GLenum pname GLfloat *params))


#| Drawing Functions |#

(defun-ogb :void "OPENGL32" "glBegin" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glEnd" ( ))
(defun-ogb :void "OPENGL32" "glVertex2d" (GLdouble x GLdouble y ))
(defun-ogb :void "OPENGL32" "glVertex2f" (GLfloat x GLfloat y ))
(defun-ogb :void "OPENGL32" "glVertex2i" (GLint x GLint y ))
(defun-ogb :void "OPENGL32" "glVertex2s" (GLshort x GLshort y ))
(defun-ogb :void "OPENGL32" "glVertex3d" (GLdouble x GLdouble y GLdouble z ))
(defun-ogb :void "OPENGL32" "glVertex3f" (GLfloat x GLfloat y GLfloat z ))
(defun-ogb :void "OPENGL32" "glVertex3i" (GLint x GLint y GLint z ))
(defun-ogb :void "OPENGL32" "glVertex3s" (GLshort x GLshort y GLshort z ))
(defun-ogb :void "OPENGL32" "glVertex4d" (GLdouble x GLdouble y GLdouble z GLdouble w ))
(defun-ogb :void "OPENGL32" "glVertex4f" (GLfloat x GLfloat y GLfloat z GLfloat w ))
(defun-ogb :void "OPENGL32" "glVertex4i" (GLint x GLint y GLint z GLint w ))
(defun-ogb :void "OPENGL32" "glVertex4s" (GLshort x GLshort y GLshort z GLshort w ))

(defun-ogb :void "OPENGL32" "glVertex2dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glVertex2fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glVertex2iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glVertex2sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glVertex3dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glVertex3fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glVertex3iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glVertex3sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glVertex4dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glVertex4fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glVertex4iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glVertex4sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glNormal3b" (GLbyte nx GLbyte ny GLbyte nz ))
(defun-ogb :void "OPENGL32" "glNormal3d" (GLdouble nx GLdouble ny GLdouble nz ))
(defun-ogb :void "OPENGL32" "glNormal3f" (GLfloat nx GLfloat ny GLfloat nz ))
(defun-ogb :void "OPENGL32" "glNormal3i" (GLint nx GLint ny GLint nz ))
(defun-ogb :void "OPENGL32" "glNormal3s" (GLshort nx GLshort ny GLshort nz ))
;;;(defun-ogb :void "OPENGL32" "glNormal3bv" (GLbyte *v ))
(defun-ogb :void "OPENGL32" "glNormal3dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glNormal3fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glNormal3iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glNormal3sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glIndexd" (GLdouble c ))
(defun-ogb :void "OPENGL32" "glIndexf" (GLfloat c ))
(defun-ogb :void "OPENGL32" "glIndexi" (GLint c ))
(defun-ogb :void "OPENGL32" "glIndexs" (GLshort c ))
(defun-ogb :void "OPENGL32" "glIndexub" (GLubyte c ))
(defun-ogb :void "OPENGL32" "glIndexdv" (GLdouble *c ))
(defun-ogb :void "OPENGL32" "glIndexfv" (GLfloat *c ))
(defun-ogb :void "OPENGL32" "glIndexiv" (GLint *c ))
(defun-ogb :void "OPENGL32" "glIndexsv" (GLshort *c ))
(defun-ogb :void "OPENGL32" "glIndexubv" (GLubyte *c ))
(defun-ogb :void "OPENGL32" "glColor3b" (GLbyte red GLbyte green GLbyte blue ))
(defun-ogb :void "OPENGL32" "glColor3d" (GLdouble red GLdouble green GLdouble blue ))
(defun-ogb :void "OPENGL32" "glColor3f" (GLfloat red GLfloat green GLfloat blue ))
(defun-ogb :void "OPENGL32" "glColor3i" (GLint red GLint green GLint blue ))
(defun-ogb :void "OPENGL32" "glColor3s" (GLshort red GLshort green GLshort blue ))
(defun-ogb :void "OPENGL32" "glColor3ub" (GLubyte red GLubyte green GLubyte blue ))
(defun-ogb :void "OPENGL32" "glColor3ui" (GLuint red GLuint green GLuint blue ))
(defun-ogb :void "OPENGL32" "glColor3us" (GLushort red GLushort green GLushort blue ))
(defun-ogb :void "OPENGL32" "glColor4b" (GLbyte red GLbyte green GLbyte blue GLbyte alpha ))
(defun-ogb :void "OPENGL32" "glColor4d" (GLdouble red GLdouble green GLdouble blue GLdouble alpha ))
(defun-ogb :void "OPENGL32" "glColor4f" (GLfloat red GLfloat green GLfloat blue GLfloat alpha ))
(defun-ogb :void "OPENGL32" "glColor4i" (GLint red GLint green GLint blue GLint alpha ))
(defun-ogb :void "OPENGL32" "glColor4s" (GLshort red GLshort green GLshort blue GLshort alpha ))
(defun-ogb :void "OPENGL32" "glColor4ub" (GLubyte red GLubyte green GLubyte blue GLubyte alpha ))
(defun-ogb :void "OPENGL32" "glColor4ui" (GLuint red GLuint green GLuint blue GLuint alpha ))
(defun-ogb :void "OPENGL32" "glColor4us" (GLushort red GLushort green GLushort blue GLushort alpha ))
;;;(defun-ogb :void "OPENGL32" "glColor3bv" (GLbyte *v ))
(defun-ogb :void "OPENGL32" "glColor3dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glColor3fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glColor3iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glColor3sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glColor3ubv" (GLubyte *v ))
(defun-ogb :void "OPENGL32" "glColor3uiv" (GLuint *v ))
(defun-ogb :void "OPENGL32" "glColor3usv" (GLushort *v ))
;;;(defun-ogb :void "OPENGL32" "glColor4bv" (GLbyte *v ))
(defun-ogb :void "OPENGL32" "glColor4dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glColor4fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glColor4iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glColor4sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glColor4ubv" (GLubyte *v ))
(defun-ogb :void "OPENGL32" "glColor4uiv" (GLuint *v ))
(defun-ogb :void "OPENGL32" "glColor4usv" (GLushort *v ))
(defun-ogb :void "OPENGL32" "glTexCoord1d" (GLdouble s ))
(defun-ogb :void "OPENGL32" "glTexCoord1f" (GLfloat s ))
(defun-ogb :void "OPENGL32" "glTexCoord1i" (GLint s ))
(defun-ogb :void "OPENGL32" "glTexCoord1s" (GLshort s ))
(defun-ogb :void "OPENGL32" "glTexCoord2d" (GLdouble s GLdouble tt ))
(defun-ogb :void "OPENGL32" "glTexCoord2f" (GLfloat s GLfloat tt ))
(defun-ogb :void "OPENGL32" "glTexCoord2i" (GLint s GLint tt ))
(defun-ogb :void "OPENGL32" "glTexCoord2s" (GLshort s GLshort tt ))
(defun-ogb :void "OPENGL32" "glTexCoord3d" (GLdouble s GLdouble tt GLdouble r ))
(defun-ogb :void "OPENGL32" "glTexCoord3f" (GLfloat s GLfloat tt GLfloat r ))
(defun-ogb :void "OPENGL32" "glTexCoord3i" (GLint s GLint tt GLint r ))
(defun-ogb :void "OPENGL32" "glTexCoord3s" (GLshort s GLshort tt GLshort r ))
(defun-ogb :void "OPENGL32" "glTexCoord4d" (GLdouble s GLdouble tt GLdouble r GLdouble q ))
(defun-ogb :void "OPENGL32" "glTexCoord4f" (GLfloat s GLfloat tt GLfloat r GLfloat q ))
(defun-ogb :void "OPENGL32" "glTexCoord4i" (GLint s GLint tt GLint r GLint q ))
(defun-ogb :void "OPENGL32" "glTexCoord4s" (GLshort s GLshort tt GLshort r GLshort q ))
(defun-ogb :void "OPENGL32" "glTexCoord1dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glTexCoord1fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glTexCoord1iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glTexCoord1sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glTexCoord2dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glTexCoord2fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glTexCoord2iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glTexCoord2sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glTexCoord3dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glTexCoord3fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glTexCoord3iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glTexCoord3sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glTexCoord4dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glTexCoord4fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glTexCoord4iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glTexCoord4sv" (GLshort *v ))
(defun-ffx :void "opengl32" "glTexCoordPointer" (GLint size GLenum type GLsizei stride GLvoid *pointer))
(defun-ffx :void "opengl32" "glTexEnvf" (GLenum target GLenum pname GLfloat param))
(defun-ffx :void "opengl32" "glTexEnvfv" (GLenum target GLenum pname GLfloat *params))
(defun-ffx :void "opengl32" "glTexEnvi" (GLenum target GLenum pname GLint param))
(defun-ffx :void "opengl32" "glTexEnviv" (GLenum target GLenum pname GLint *params))
(defun-ffx :void "opengl32" "glTexGend" (GLenum coord GLenum pname GLdouble param))
(defun-ffx :void "opengl32" "glTexGendv" (GLenum coord GLenum pname GLdouble *params))
(defun-ffx :void "opengl32" "glTexGenf" (GLenum coord GLenum pname GLfloat param))
(defun-ffx :void "opengl32" "glTexGenfv" (GLenum coord GLenum pname GLfloat *params))
(defun-ffx :void "opengl32" "glTexGeni" (GLenum coord GLenum pname GLint param))
(defun-ffx :void "opengl32" "glTexGeniv" (GLenum coord GLenum pname GLint *params))
;;;(defun-ffx :void "opengl32" "glTexImage1D" (GLenum target GLint level GLint internalformat 
;;;                                             GLsizei width GLint border GLenum format 
;;;                                             GLenum type GLvoid *pixels))
(defun-ffx :void "opengl32" "glTexImage2D" (GLenum target GLint level GLint internalformat 
                                             GLsizei width GLsizei height GLint border 
                                             GLenum format GLenum type GLvoid *pixels))
(defun-ffx :void "opengl32" "glTexParameterf" (GLenum target GLenum pname GLfloat param))
(defun-ffx :void "opengl32" "glTexParameterfv" (GLenum target GLenum pname GLfloat *params))
(defun-ffx :void "opengl32" "glTexParameteri" (GLenum target GLenum pname GLint param))
(defun-ffx :void "opengl32" "glTexParameteriv" (GLenum target GLenum pname GLint *params))
;;;(defun-ffx :void "opengl32" "glTexSubImage1D" (GLenum target GLint level GLint xoffset GLsizei width GLenum format GLenum type GLvoid *pixels))
;;;(defun-ffx :void "opengl32" "glTexSubImage2D" (GLenum target GLint level GLint xoffset GLint yoffset GLsizei width GLsizei height GLenum format GLenum type GLvoid *pixels))

(defun-ffx :void "opengl32" "glGenTextures" (GLsizei n GLuint *textures))
(defun-ffx :void "opengl32" "glBindTexture" (GLenum target GLuint texture))
(defun-ffx :void "opengl32" "glDeleteTextures" (GLsizei n GLuint *textures))



;;;/* TextureGenParameter */
;;;#define GL_TEXTURE_GEN_MODE               0x2500
;;;#define GL_OBJECT_PLANE                   0x2501
;;;#define GL_EYE_PLANE                      0x2502
;;;
;;;#define GL_NEAREST_MIPMAP_NEAREST         0x2700
;;;#define GL_LINEAR_MIPMAP_NEAREST          0x2701
;;;#define GL_NEAREST_MIPMAP_LINEAR          0x2702
;;;#define GL_LINEAR_MIPMAP_LINEAR           0x2703
;;;
;;;/* TextureParameterName */
;;;#define GL_TEXTURE_MAG_FILTER             0x2800
;;;#define GL_TEXTURE_MIN_FILTER             0x2801
;;;#define GL_TEXTURE_WRAP_S                 0x2802
;;;#define GL_TEXTURE_WRAP_T                 0x2803
;;;/*      GL_TEXTURE_BORDER_COLOR */
;;;/*      GL_TEXTURE_PRIORITY */
;;;
;;;/* TextureTarget */
;;;/*      GL_TEXTURE_1D */
;;;/*      GL_TEXTURE_2D */
;;;/*      GL_PROXY_TEXTURE_1D */
;;;/*      GL_PROXY_TEXTURE_2D */

(defun-ogb :void "OPENGL32" "glRasterPos2d" (GLdouble x GLdouble y ))
(defun-ogb :void "OPENGL32" "glRasterPos2f" (GLfloat x GLfloat y ))
(defun-ogb :void "OPENGL32" "glRasterPos2i" (GLint x GLint y ))
(defun-ogb :void "OPENGL32" "glRasterPos2s" (GLshort x GLshort y ))
(defun-ogb :void "OPENGL32" "glRasterPos3d" (GLdouble x GLdouble y GLdouble z ))
(defun-ogb :void "OPENGL32" "glRasterPos3f" (GLfloat x GLfloat y GLfloat z ))
(defun-ogb :void "OPENGL32" "glRasterPos3i" (GLint x GLint y GLint z ))
(defun-ogb :void "OPENGL32" "glRasterPos3s" (GLshort x GLshort y GLshort z ))
(defun-ogb :void "OPENGL32" "glRasterPos4d" (GLdouble x GLdouble y GLdouble z GLdouble w ))
(defun-ogb :void "OPENGL32" "glRasterPos4f" (GLfloat x GLfloat y GLfloat z GLfloat w ))
(defun-ogb :void "OPENGL32" "glRasterPos4i" (GLint x GLint y GLint z GLint w ))
(defun-ogb :void "OPENGL32" "glRasterPos4s" (GLshort x GLshort y GLshort z GLshort w ))
(defun-ogb :void "OPENGL32" "glRasterPos2dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glRasterPos2fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glRasterPos2iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glRasterPos2sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glRasterPos3dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glRasterPos3fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glRasterPos3iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glRasterPos3sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glRasterPos4dv" (GLdouble *v ))
(defun-ogb :void "OPENGL32" "glRasterPos4fv" (GLfloat *v ))
(defun-ogb :void "OPENGL32" "glRasterPos4iv" (GLint *v ))
(defun-ogb :void "OPENGL32" "glRasterPos4sv" (GLshort *v ))
(defun-ogb :void "OPENGL32" "glRectd" (GLdouble x1 GLdouble y1 GLdouble x2 GLdouble y2 ))
(defun-ogb :void "OPENGL32" "glRectf" (GLfloat x1 GLfloat y1 GLfloat x2 GLfloat y2 ))
(defun-ogb :void "OPENGL32" "glRecti" (GLint x1 GLint y1 GLint x2 GLint y2 ))
(defun-ogb :void "OPENGL32" "glRects" (GLshort x1 GLshort y1 GLshort x2 GLshort y2 ))
(defun-ogb :void "OPENGL32" "glRectdv" (GLdouble *v1 GLdouble *v2 ))
(defun-ogb :void "OPENGL32" "glRectfv" (GLfloat *v1 GLfloat *v2 ))
(defun-ogb :void "OPENGL32" "glRectiv" (GLint *v1 GLint *v2 ))
(defun-ogb :void "OPENGL32" "glRectsv" (GLshort *v1 GLshort *v2 ))


#| Lighting |#
(defun-ogb :void "OPENGL32" "glShadeModel" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glLightf" (GLenum light GLenum pname GLfloat param ))
(defun-ogb :void "OPENGL32" "glLighti" (GLenum light GLenum pname GLint param ))
(defun-ogb :void "OPENGL32" "glLightfv" (GLenum light GLenum pname GLfloat *params ))
(defun-ogb :void "OPENGL32" "glLightiv" (GLenum light GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glGetLightfv" (GLenum light GLenum pname GLfloat *params ))
(defun-ogb :void "OPENGL32" "glGetLightiv" (GLenum light GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glLightModelf" (GLenum pname GLfloat param ))
(defun-ogb :void "OPENGL32" "glLightModeli" (GLenum pname GLint param ))
(defun-ogb :void "OPENGL32" "glLightModelfv" (GLenum pname GLfloat *params ))
(defun-ogb :void "OPENGL32" "glLightModeliv" (GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glMaterialf" (GLenum face GLenum pname GLfloat param ))
(defun-ogb :void "OPENGL32" "glMateriali" (GLenum face GLenum pname GLint param ))

(defun-ogb :void "OPENGL32" "glMaterialiv" (GLenum face GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glGetMaterialfv" (GLenum face GLenum pname GLfloat *params ))
(defun-ogb :void "OPENGL32" "glGetMaterialiv" (GLenum face GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glColorMaterial" (GLenum face GLenum mode ))

#| Fog |#
(defun-ogb :void "OPENGL32" "glFogf" (GLenum pname GLfloat param))
(defun-ogb :void "OPENGL32" "glFogi" (GLenum pname GLint param))
(defun-ogb :void "OPENGL32" "glFogfv" (GLenum pname GLfloat *params))
(defun-ogb :void "OPENGL32" "glFogiv" (GLenum pname GLint *params))

#| Selection and Feedback |#
(defun-ogb :void "OPENGL32" "glFeedbackBuffer" (GLsizei size GLenum type GLfloat *buffer))
(defun-ogb :void "OPENGL32" "glPassThrough" (GLfloat token))
(defun-ogb :void "OPENGL32" "glSelectBuffer" (GLsizei size GLuint *buffer ))
(defun-ogb :void "OPENGL32" "glInitNames" ())
(defun-ogb :void "OPENGL32" "glLoadName" (GLuint name))
(defun-ogb :void "OPENGL32" "glPushName" (GLuint name))
(defun-ogb :void "OPENGL32" "glPopName" ())


#| Miscellaneous |#
(defun-ogb :void "OPENGL32" "glClearIndex" (GLfloat c ))
(defun-ogb :void "OPENGL32" "glClearColor" (GLclampf red GLclampf green GLclampf blue GLclampf alpha ))
(defun-ogb :void "OPENGL32" "glClear" (GLbitfield mask ))
(defun-ogb :void "OPENGL32" "glIndexMask" (GLuint mask ))
(defun-ogb :void "OPENGL32" "glColorMask" (GLboolean red GLboolean green GLboolean blue GLboolean alpha ))
(defun-ogb :void "OPENGL32" "glAlphaFunc" (GLenum func GLclampf ref ))
(defun-ogb :void "OPENGL32" "glBlendFunc" (GLenum sfactor GLenum dfactor ))
(defun-ogb :void "OPENGL32" "glLogicOp" (GLenum opcode ))
(defun-ogb :void "OPENGL32" "glCullFace" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glFrontFace" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glPointSize" (GLfloat size ))
(defun-ogb :void "OPENGL32" "glLineWidth" (GLfloat width ))
(defun-ogb :void "OPENGL32" "glLineStipple" (GLint factor GLushort pattern ))
(defun-ogb :void "OPENGL32" "glPolygonMode" (GLenum face GLenum mode ))
(defun-ogb :void "OPENGL32" "glPolygonOffset" (GLfloat factor GLfloat units ))
(defun-ogb :void "OPENGL32" "glPolygonStipple" (GLubyte *mask ))
(defun-ogb :void "OPENGL32" "glGetPolygonStipple" (GLubyte *mask ))
(defun-ogb :void "OPENGL32" "glEdgeFlag" (GLboolean flag ))
(defun-ogb :void "OPENGL32" "glEdgeFlagv" (GLboolean *flag ))
(defun-ogb :void "OPENGL32" "glScissor" (GLint x GLint y GLsizei width GLsizei height))
(defun-ogb :void "OPENGL32" "glClipPlane" (GLenum plane GLdouble *equation ))
(defun-ogb :void "OPENGL32" "glGetClipPlane" (GLenum plane GLdouble *equation ))

(defun-ogb :void "OPENGL32" "glDrawArrays" (GLenum mode GLint first GLsizei count))
(defun-ogb :void "OPENGL32" "glDrawBuffer" (GLenum mode))

(defun-ogb :void "OPENGL32" "glDrawElements"
  (GLenum mode GLsizei count GLenum type GLvoid *indices))

(defun-ogb :void "OPENGL32" "glDrawPixels"
  (GLsizei width GLsizei height GLenum format GLenum type GLvoid *pixels))

(defun-ogb :void "OPENGL32" "glReadBuffer" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glEnable" (GLenum cap ))
(defun-ogb :void "OPENGL32" "glDisable" (GLenum cap ))
(defun-ogb GLboolean "OPENGL32" "glIsEnabled" (GLenum cap ))
(defun-ogb :void "OPENGL32" "glEnableClientState" (GLenum cap ))  #| 1.1 |#
(defun-ogb :void "OPENGL32" "glDisableClientState" (GLenum cap ))  #| 1.1 |#
(defun-ogb :void "OPENGL32" "glGetBooleanv" (GLenum pname GLboolean *params ))
(defun-ogb :void "OPENGL32" "glGetDoublev" (GLenum pname GLdouble *params ))
(defun-ogb :void "OPENGL32" "glGetFloatv" (GLenum pname GLfloat *params ))
(defun-ogb :void "OPENGL32" "glGetIntegerv" (GLenum pname GLint *params ))
(defun-ogb :void "OPENGL32" "glPushAttrib" (GLbitfield mask ))
(defun-ogb :void "OPENGL32" "glPopAttrib"  ())
(defun-ogb :void "OPENGL32" "glPushClientAttrib" (GLbitfield mask ))  #| 1.1 |#
(defun-ogb :void "OPENGL32" "glPopClientAttrib"  ())  #| 1.1 |#
(defun-ogb GLint "OPENGL32" "glRenderMode" (GLenum mode ))
(defun-ogb GLenum "OPENGL32" "glGetError"  ())
(defun-ogb (* GLubyte) "OPENGL32" "glGetString" (GLenum name ))
(defun-ogb :void "OPENGL32" "glFinish"  ())
(defun-ogb :void "OPENGL32" "glHint" (GLenum target GLenum mode ))

#| Depth Buffer |#
(defun-ogb :void "OPENGL32" "glClearDepth" (GLclampd depth ))
(defun-ogb :void "OPENGL32" "glDepthFunc" (GLenum func ))
(defun-ogb :void "OPENGL32" "glDepthMask" (GLboolean flag ))
(defun-ogb :void "OPENGL32" "glDepthRange" (GLclampd near_val GLclampd far_val ))

#| Accumulation Buffer |#
(defun-ogb :void "OPENGL32" "glClearAccum" (GLfloat red GLfloat green GLfloat blue GLfloat alpha ))
(defun-ogb :void "OPENGL32" "glAccum" (GLenum op GLfloat value ))

#| Transformation |#
(defun-ogb :void "OPENGL32" "glMatrixMode" (GLenum mode ))
(defun-ogb :void "OPENGL32" "glOrtho" (GLdouble left GLdouble right GLdouble bottom GLdouble top GLdouble near_val GLdouble far_val ))
(defun-ogb :void "OPENGL32" "glFrustum" (GLdouble left GLdouble right GLdouble bottom GLdouble top GLdouble near_val GLdouble far_val ))
(defun-ogb :void "OPENGL32" "glViewport" (GLint x GLint y GLsizei width GLsizei height ))
(defun-ogb :void "OPENGL32" "glPushMatrix" ( ))
(defun-ogb :void "OPENGL32" "glPopMatrix" ( ))
(defun-ogb :void "OPENGL32" "glLoadIdentity" ( ))
(defun-ogb :void "OPENGL32" "glLoadMatrixd" (GLdouble *m ))
(defun-ogb :void "OPENGL32" "glLoadMatrixf" (GLfloat *m ))
(defun-ogb :void "OPENGL32" "glMultMatrixd" (GLdouble *m ))
(defun-ogb :void "OPENGL32" "glMultMatrixf" (GLfloat *m ))
(defun-ogb :void "OPENGL32" "glRotated" (GLdouble angle GLdouble x GLdouble y GLdouble z ))
(defun-ogb :void "OPENGL32" "glRotatef" (GLfloat angle GLfloat x GLfloat y GLfloat z ))
(defun-ogb :void "OPENGL32" "glScaled" (GLdouble x GLdouble y GLdouble z ))
(defun-ogb :void "OPENGL32" "glScalef" (GLfloat x GLfloat y GLfloat z ))
(defun-ogb :void "OPENGL32" "glTranslated" (GLdouble x GLdouble y GLdouble z ))
(defun-ogb :void "OPENGL32" "glTranslatef" (GLfloat x GLfloat y GLfloat z ))

(defun-ogb :void "OPENGL32" "glPixelMapfv" (GLenum map GLsizei mapsize GLfloat *values))
(defun-ogb :void "OPENGL32" "glPixelMapuiv" (GLenum map GLsizei mapsize GLuint *values))
(defun-ogb :void "OPENGL32" "glPixelMapusv" (GLenum map GLsizei mapsize GLushort *values))
(defun-ogb :void "OPENGL32" "glPixelStoref" (GLenum pname GLfloat param))
(defun-ogb :void "OPENGL32" "glPixelStorei" (GLenum pname GLint param))
(defun-ogb :void "OPENGL32" "glPixelTransferf" (GLenum pname GLfloat param))
(defun-ogb :void "OPENGL32" "glPixelTransferi" (GLenum pname GLint param))
(defun-ogb :void "OPENGL32" "glPixelZoom" (GLfloat xfactor GLfloat yfactor))

#| Display Lists |#
(defun-ogb GLboolean "OPENGL32" "glIsList" (GLuint list))
(defun-ogb :void "OPENGL32" "glDeleteLists" (GLuint list GLsizei range ))
(defun-ogb GLuint "OPENGL32" "glGenLists" (GLsizei range ))
(defun-ogb :void "OPENGL32" "glNewList" (GLuint list GLenum mode ))
(defun-ogb :void "OPENGL32" "glEndList" ())
(defun-ogb :void "OPENGL32" "glCallList" (GLuint list ))
(defun-ogb :void "OPENGL32" "glCallLists" (GLsizei n GLenum type GLvoid *lists))
(defun-ogb :void "OPENGL32" "glListBase" (GLuint base))