;; -*- mode: Lisp; Syntax: Common-Lisp; Package: ogb; -*-
;;;
;;; Copyright  1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :opengl-bindings)

(defun-ogb (* GLubyte)  "GLU32" "gluErrorString" (GLenum error))
;;;(defun-ogb void "GLU32" "gluGetNurbsProperty" (GLUnurbs *nurb GLenum property GLfloat *data))
;;;(defun-ogb GLubyte  *"GLU32" "gluGetString" (GLenum name))
;;;(defun-ogb void "GLU32" "gluGetTessProperty" (GLUtesselator *tess GLenum which GLdouble *data))
;;;(defun-ogb void "GLU32" "gluLoadSamplingMatrices" (GLUnurbs *nurb GLfloat *model GLfloat *perspective GLint *view))

(defun-ogb :int "GLU32" "gluBuild2DMipmaps" (GLenum  target
                                               GLint  components
                                               GLint  width
                                               GLint  height
                                               GLenum format
                                               GLenum type
                                               :void  *data))

(defun-ogb :void "GLU32" "gluLookAt" (GLdouble eyeX GLdouble eyeY GLdouble eyeZ 
                                       GLdouble centerX GLdouble centerY GLdouble centerZ 
                                       GLdouble upX GLdouble upY GLdouble upZ))
;;;(defun-ogb GLUnurbs *"GLU32" "gluNewNurbsRenderer" ())
;;;(defun-ogb GLUquadric *"GLU32" "gluNewQuadric" ())
;;;(defun-ogb GLUtesselator *"GLU32" "gluNewTess" ())
;;;(defun-ogb void "GLU32" "gluNextContour" (GLUtesselator *tess GLenum type))
;;;(defun-ogb void "GLU32" "gluNurbsCurve" (GLUnurbs *nurb GLint knotCount GLfloat *knots GLint stride GLfloat *control GLint order GLenum type))
;;;(defun-ogb void "GLU32" "gluNurbsProperty" (GLUnurbs *nurb GLenum property GLfloat value))
;;;(defun-ogb void "GLU32" "gluNurbsSurface" (GLUnurbs *nurb GLint sKnotCount GLfloat *sKnots GLint tKnotCount GLfloat *tKnots GLint sStride GLint tStride GLfloat *control GLint sOrder GLint tOrder GLenum type))
;;;(defun-ogb :void "GLU32" "gluOrtho2D" (GLdouble left GLdouble right 
;;;                                        GLdouble bottom GLdouble top))
;;;(defun-ogb void "GLU32" "gluPartialDisk" (GLUquadric *quad GLdouble inner GLdouble outer GLint slices GLint loops GLdouble start GLdouble sweep))


(defun-ogb :void "GLU32" "gluPerspective" (GLdouble fovy GLdouble aspect GLdouble zNear GLdouble zFar))
(defun-ogb :void "GLU32" "gluPickMatrix" (GLdouble x GLdouble y GLdouble delX GLdouble delY GLint *viewport))
(defun-ogb GLint "GLU32" "gluProject" (GLdouble objX GLdouble objY GLdouble objZ 
                                        GLdouble *model GLdouble *proj 
                                        GLint *view GLdouble *winX GLdouble *winY GLdouble *winZ))
;;;(defun-ogb void "GLU32" "gluPwlCurve" (GLUnurbs *nurb GLint count GLfloat *data GLint stride GLenum type))
;;;(defun-ogb void "GLU32" "gluQuadricDrawStyle" (GLUquadric *quad GLenum draw))
;;;(defun-ogb void "GLU32" "gluQuadricNormals" (GLUquadric *quad GLenum normal))
;;;(defun-ogb void "GLU32" "gluQuadricOrientation" (GLUquadric *quad GLenum orientation))
;;;(defun-ogb void "GLU32" "gluQuadricTexture" (GLUquadric *quad GLboolean texture))
;;;(defun-ogb GLint "GLU32" "gluScaleImage" (GLenum format GLsizei wIn GLsizei hIn GLenum typeIn void *dataIn GLsizei wOut GLsizei hOut GLenum typeOut GLvoid *dataOut))
;;;(defun-ogb void "GLU32" "gluSphere" (GLUquadric *quad GLdouble radius GLint slices GLint stacks))
;;;(defun-ogb void "GLU32" "gluTessBeginContour" (GLUtesselator *tess))
;;;(defun-ogb void "GLU32" "gluTessBeginPolygon" (GLUtesselator *tess GLvoid *data))
;;;(defun-ogb void "GLU32" "gluTessEndContour" (GLUtesselator *tess))
;;;(defun-ogb void "GLU32" "gluTessEndPolygon" (GLUtesselator *tess))
;;;(defun-ogb void "GLU32" "gluTessNormal" (GLUtesselator *tess GLdouble valueX GLdouble valueY GLdouble valueZ))
;;;(defun-ogb void "GLU32" "gluTessProperty" (GLUtesselator *tess GLenum which GLdouble data))
;;;(defun-ogb void "GLU32" "gluTessVertex" (GLUtesselator *tess GLdouble *location GLvoid *data))
(defun-ogb GLint "GLU32" "gluUnProject" (GLdouble winX GLdouble winY GLdouble winZ 
                                          GLdouble *model GLdouble *proj 
                                          GLint *view GLdouble *objX GLdouble *objY GLdouble *objZ))
