;; -*- mode: Lisp; Syntax: Common-Lisp; Package: ogb; -*-
;;;
;;; Copyright  1995,2003 by Kenneth William Tilton.
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy 
;;; of this software and associated documentation files (the "Software"), to deal 
;;; in the Software without restriction, including without limitation the rights 
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
;;; copies of the Software, and to permit persons to whom the Software is furnished 
;;; to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in 
;;; all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
;;; IN THE SOFTWARE.

(in-package :opengl-bindings)

#| Display mode bit masks. |#
(dfc GLUT_RGB		0)
(dfc GLUT_RGBA		GLUT_RGB)
(dfc GLUT_INDEX		1)
(dfc GLUT_SINGLE		0)
(dfc GLUT_DOUBLE		2)
(dfc GLUT_ACCUM		4)
(dfc GLUT_ALPHA		8)
(dfc GLUT_DEPTH		16)
(dfc GLUT_STENCIL		32)
(dfc GLUT_MULTISAMPLE	128)
(dfc GLUT_STEREO		256)
(dfc GLUT_LUMINANCE	512)


#| Mouse buttons. |#
(dfc GLUT_LEFT_BUTTON		0)
(dfc GLUT_MIDDLE_BUTTON		1)
(dfc GLUT_RIGHT_BUTTON		2)
(dfc GLUT_MOUSE_WHEEL_CLICK   3)
(dfc GLUT_MOUSE_WHEEL_BACK    4)
(dfc GLUT_MOUSE_WHEEL_FWD     5)

#| Mouse button  state. |#
(dfc GLUT_DOWN			0)
(dfc GLUT_UP			1)


#| function keys |#
(dfc GLUT_KEY_F1			1)
(dfc GLUT_KEY_F2			2)
(dfc GLUT_KEY_F3			3)
(dfc GLUT_KEY_F4			4)
(dfc GLUT_KEY_F5			5)
(dfc GLUT_KEY_F6			6)
(dfc GLUT_KEY_F7			7)
(dfc GLUT_KEY_F8			8)
(dfc GLUT_KEY_F9			9)
(dfc GLUT_KEY_F10			10)
(dfc GLUT_KEY_F11			11)
(dfc GLUT_KEY_F12			12)
#| directional keys |#
(dfc GLUT_KEY_LEFT		100)
(dfc GLUT_KEY_UP			101)
(dfc GLUT_KEY_RIGHT		102)
(dfc GLUT_KEY_DOWN		103)
(dfc GLUT_KEY_PAGE_UP		104)
(dfc GLUT_KEY_PAGE_DOWN		105)
(dfc GLUT_KEY_HOME		106)
(dfc GLUT_KEY_END			107)
(dfc GLUT_KEY_INSERT		108)


#| Entry/exit  state. |#
(dfc GLUT_LEFT			0)
(dfc GLUT_ENTERED			1)


#| Menu usage  state. |#
(dfc GLUT_MENU_NOT_IN_USE	0)
(dfc GLUT_MENU_IN_USE		1)


#| Visibility  state. |#
(dfc GLUT_NOT_VISIBLE		0)
(dfc GLUT_VISIBLE			1)

#| Window status  state. |#
(dfc GLUT_HIDDEN			0)
(dfc GLUT_FULLY_RETAINED	1)
(dfc GLUT_PARTIALLY_RETAINED	2)
(dfc GLUT_FULLY_COVERED		3)

#| Color index component selection values. |#
(dfc GLUT_RED			0)
(dfc GLUT_GREEN			1)
(dfc GLUT_BLUE			2)

#| Stroke font constants (use these in GLUT program). |#
(dfc GLUT_STROKE_ROMAN		0)
(dfc GLUT_STROKE_MONO_ROMAN	1)

#| Bitmap font constants (use these in GLUT program). |#
(dfc GLUT_BITMAP_9_BY_15		2)
(dfc GLUT_BITMAP_8_BY_13		3)
(dfc GLUT_BITMAP_TIMES_ROMAN_10	4)
(dfc GLUT_BITMAP_TIMES_ROMAN_24	5)

(dfc GLUT_BITMAP_HELVETICA_10	6)
(dfc GLUT_BITMAP_HELVETICA_12	7)
(dfc GLUT_BITMAP_HELVETICA_18	8)


#| glutGet parameters. |#
(dfc GLUT_WINDOW_X			 100)
(dfc GLUT_WINDOW_Y			 101)
(dfc GLUT_WINDOW_WIDTH		 102)
(dfc GLUT_WINDOW_HEIGHT		 103)
(dfc GLUT_WINDOW_BUFFER_SIZE		 104)
(dfc GLUT_WINDOW_STENCIL_SIZE	 105)
(dfc GLUT_WINDOW_DEPTH_SIZE		 106)
(dfc GLUT_WINDOW_RED_SIZE		 107)
(dfc GLUT_WINDOW_GREEN_SIZE		 108)
(dfc GLUT_WINDOW_BLUE_SIZE		 109)
(dfc GLUT_WINDOW_ALPHA_SIZE		 110)
(dfc GLUT_WINDOW_ACCUM_RED_SIZE	 111)
(dfc GLUT_WINDOW_ACCUM_GREEN_SIZE	 112)
(dfc GLUT_WINDOW_ACCUM_BLUE_SIZE	 113)
(dfc GLUT_WINDOW_ACCUM_ALPHA_SIZE	 114)
(dfc GLUT_WINDOW_DOUBLEBUFFER	 115)
(dfc GLUT_WINDOW_RGBA		 116)
(dfc GLUT_WINDOW_PARENT		 117)
(dfc GLUT_WINDOW_NUM_CHILDREN	 118)
(dfc GLUT_WINDOW_COLORMAP_SIZE	 119)

(dfc GLUT_WINDOW_NUM_SAMPLES		 120)
(dfc GLUT_WINDOW_STEREO		 121)
(dfc GLUT_WINDOW_CURSOR		 122)

(dfc GLUT_SCREEN_WIDTH		 200)
(dfc GLUT_SCREEN_HEIGHT		 201)
(dfc GLUT_SCREEN_WIDTH_MM		 202)
(dfc GLUT_SCREEN_HEIGHT_MM		 203)
(dfc GLUT_MENU_NUM_ITEMS		 300)
(dfc GLUT_DISPLAY_MODE_POSSIBLE	 400)
(dfc GLUT_INIT_WINDOW_X		 500)
(dfc GLUT_INIT_WINDOW_Y		 501)
(dfc GLUT_INIT_WINDOW_WIDTH		 502)
(dfc GLUT_INIT_WINDOW_HEIGHT		 503)
(dfc GLUT_INIT_DISPLAY_MODE		 504)

(dfc GLUT_ELAPSED_TIME		 700)
(dfc GLUT_WINDOW_FORMAT_ID		 123)
(dfc GLUT_INIT_STATE #x007C)


#| glutDeviceGet parameters. |#
(dfc GLUT_HAS_KEYBOARD		 600)
(dfc GLUT_HAS_MOUSE			 601)
(dfc GLUT_HAS_SPACEBALL		 602)
(dfc GLUT_HAS_DIAL_AND_BUTTON_BOX	 603)
(dfc GLUT_HAS_TABLET			 604)
(dfc GLUT_NUM_MOUSE_BUTTONS		 605)
(dfc GLUT_NUM_SPACEBALL_BUTTONS	 606)
(dfc GLUT_NUM_BUTTON_BOX_BUTTONS	 607)
(dfc GLUT_NUM_DIALS			 608)
(dfc GLUT_NUM_TABLET_BUTTONS		 609)

(dfc GLUT_DEVICE_IGNORE_KEY_REPEAT    610)
(dfc GLUT_DEVICE_KEY_REPEAT           611)
(dfc GLUT_HAS_JOYSTICK		 612)
(dfc GLUT_OWNS_JOYSTICK		 613)
(dfc GLUT_JOYSTICK_BUTTONS		 614)
(dfc GLUT_JOYSTICK_AXES		 615)
(dfc GLUT_JOYSTICK_POLL_RATE		 616)


#| glutLayerGet parameters. |#
(dfc GLUT_OVERLAY_POSSIBLE            800)
(dfc GLUT_LAYER_IN_USE		 801)
(dfc GLUT_HAS_OVERLAY		 802)
(dfc GLUT_TRANSPARENT_INDEX		 803)
(dfc GLUT_NORMAL_DAMAGED		 804)
(dfc GLUT_OVERLAY_DAMAGED		 805)


#| glutVideoResizeGet parameters. |#
(dfc GLUT_VIDEO_RESIZE_POSSIBLE	 900)
(dfc GLUT_VIDEO_RESIZE_IN_USE	 901)
(dfc GLUT_VIDEO_RESIZE_X_DELTA	 902)
(dfc GLUT_VIDEO_RESIZE_Y_DELTA	 903)
(dfc GLUT_VIDEO_RESIZE_WIDTH_DELTA	 904)
(dfc GLUT_VIDEO_RESIZE_HEIGHT_DELTA	 905)
(dfc GLUT_VIDEO_RESIZE_X		 906)
(dfc GLUT_VIDEO_RESIZE_Y		 907)
(dfc GLUT_VIDEO_RESIZE_WIDTH		 908)
(dfc GLUT_VIDEO_RESIZE_HEIGHT	 909)


#| glutUseLayer parameters. |#
(dfc GLUT_NORMAL			 0)
(dfc GLUT_OVERLAY			 1)


#| glutGetModifiers return mask. |#
(dfc GLUT_ACTIVE_SHIFT               1)
(dfc GLUT_ACTIVE_CTRL                2)
(dfc GLUT_ACTIVE_ALT                 4)

#| glutSetCursor parameters. |#
#| Basic arrows. |#
(dfc GLUT_CURSOR_RIGHT_ARROW		0)
(dfc GLUT_CURSOR_LEFT_ARROW		1)
#| Symbolic cursor shapes. |#
(dfc GLUT_CURSOR_INFO		2)
(dfc GLUT_CURSOR_DESTROY	3)
(dfc GLUT_CURSOR_HELP		4)
(dfc GLUT_CURSOR_CYCLE		5)
(dfc GLUT_CURSOR_SPRAY		6)
(dfc GLUT_CURSOR_WAIT		7)
(dfc GLUT_CURSOR_TEXT		8)
(dfc GLUT_CURSOR_CROSSHAIR		9)
#| Directional cursors. |#
(dfc GLUT_CURSOR_UP_DOWN		10)
(dfc GLUT_CURSOR_LEFT_RIGHT		11)
#| Sizing cursors. |#
(dfc GLUT_CURSOR_TOP_SIDE		12)
(dfc GLUT_CURSOR_BOTTOM_SIDE		13)
(dfc GLUT_CURSOR_LEFT_SIDE		14)
(dfc GLUT_CURSOR_RIGHT_SIDE		15)
(dfc GLUT_CURSOR_TOP_LEFT_CORNER	16)
(dfc GLUT_CURSOR_TOP_RIGHT_CORNER	17)
(dfc GLUT_CURSOR_BOTTOM_RIGHT_CORNER	18)
(dfc GLUT_CURSOR_BOTTOM_LEFT_CORNER	19)
#| Inherit from parent window. |#
(dfc GLUT_CURSOR_INHERIT		100)
#| Blank cursor. |#
(dfc GLUT_CURSOR_NONE		101)

#| Fullscreen crosshair |#
(dfc GLUT_CURSOR_FULL_CROSSHAIR	102)

#| GLUT device control sub-API. |#
#| glutSetKeyRepeat modes. |#
(dfc GLUT_KEY_REPEAT_OFF		0)
(dfc GLUT_KEY_REPEAT_ON		1)
(dfc GLUT_KEY_REPEAT_DEFAULT		2)

#| Joystick button masks. |#
(dfc GLUT_JOYSTICK_BUTTON_A		1)
(dfc GLUT_JOYSTICK_BUTTON_B		2)
(dfc GLUT_JOYSTICK_BUTTON_C		4)
(dfc GLUT_JOYSTICK_BUTTON_D		8)

#| GLUT game mode sub-API. |#
#| glutGameModeGet. |#
(dfc GLUT_GAME_MODE_ACTIVE            0)
(dfc GLUT_GAME_MODE_POSSIBLE          1)
(dfc GLUT_GAME_MODE_WIDTH             2)
(dfc GLUT_GAME_MODE_HEIGHT            3)
(dfc GLUT_GAME_MODE_PIXEL_DEPTH       4)
(dfc GLUT_GAME_MODE_REFRESH_RATE      5)
(dfc GLUT_GAME_MODE_DISPLAY_CHANGED   6)
